# Produce ARM a.out executables for pdos-generic that produce ARM a.out executables
# Note that PDPCLIB must have been built using makefile.aga

CC=gccarm
COPTS=-S -O0 -D__UNOPT__ -mapcs-32 -D__PDOS386__ \
    -D__PDOSGEN__ -D__ARMGEN__ -D__NOBIVA__ -fno-common \
    -fno-builtin -ansi -I. -Ibfd -Igas -I../pdos/pdpclib \
    -I../pdos/generic -Iinclude -Igas/config -Ild -Ibinutils \
    -Iextra -DHAVE_CONFIG_H -DPUREISO -DBUILDARM \
    -I../pdos/src

all: clean as-pdos.exe ld-pdos.exe ar-pdos.exe objdump-pdos.exe

as-pdos.exe: gas/as.o gas/app.o gas/sb.o gas/read.o gas/messages.o gas/input-scrub.o \
    gas/input-file.o gas/cond.o gas/listing.o gas/expr.o gas/symbols.o \
    gas/write.o gas/dwarf2dbg.o gas/ehopt.o gas/frags.o gas/subsegs.o \
    gas/stabs.o gas/output-file.o gas/atof-generic.o gas/flonum-copy.o \
    gas/flonum-mult.o gas/flonum-konst.o gas/macro.o gas/depend.o \
    gas/config/atof-ieee.o \
    libiberty/xmalloc.o libiberty/xexit.o libiberty/objalloc.o libiberty/xstrerror.o \
    libiberty/xstrdup.o libiberty/safe-ctype.o libiberty/fnmatch.o libiberty/hex.o \
    libiberty/strcasecmp.o libiberty/strncasecmp.o libiberty/obstack.o \
    libiberty/asprintf.o libiberty/vasprintf.o libiberty/ffs.o libiberty/lbasename.o \
    libiberty/getopt.o libiberty/getopt1.o libiberty/getruntime.o \
    libiberty/xatexit.o libiberty/concat.o \
    libiberty/alloca.o libiberty/strdup.o libiberty/snprintf.o libiberty/vsnprintf.o \
    gas/ecoff.o \
    bfd/bfd.o bfd/hash.o bfd/bfdio.o bfd/cache.o bfd/libbfd.o bfd/opncls.o \
    bfd/section.o bfd/format.o bfd/binary.o bfd/syms.o bfd/reloc.o bfd/linker.o \
    bfd/archures.o bfd/archive.o bfd/targets.o \
    bfd/stab-syms.o bfd/ihex.o bfd/tekhex.o bfd/srec.o \
    bfd/init.o \
    unixio.o \
    gas/hash.o \
    gas/config/tc-arm.o \
    bfd/cpu-arm.o \
    bfd/aout32.o \
    bfd/aout-arm.o \
    gas/config/obj-aout.o
  rm -f libbinu.a
  ararm r libbinu.a gas/app.o gas/sb.o gas/read.o gas/messages.o gas/input-scrub.o
  ararm r libbinu.a gas/input-file.o gas/cond.o gas/listing.o gas/expr.o gas/symbols.o
  ararm r libbinu.a gas/write.o gas/dwarf2dbg.o gas/ehopt.o gas/frags.o gas/subsegs.o
  ararm r libbinu.a gas/stabs.o gas/output-file.o gas/atof-generic.o gas/flonum-copy.o
  ararm r libbinu.a gas/flonum-mult.o gas/flonum-konst.o gas/macro.o gas/depend.o
  ararm r libbinu.a gas/config/atof-ieee.o
  ararm r libbinu.a libiberty/xmalloc.o libiberty/xexit.o libiberty/objalloc.o libiberty/xstrerror.o
  ararm r libbinu.a libiberty/xstrdup.o libiberty/safe-ctype.o libiberty/fnmatch.o libiberty/hex.o
  ararm r libbinu.a libiberty/strcasecmp.o libiberty/strncasecmp.o libiberty/obstack.o
  ararm r libbinu.a libiberty/asprintf.o libiberty/vasprintf.o libiberty/ffs.o libiberty/lbasename.o
  ararm r libbinu.a libiberty/getopt.o libiberty/getopt1.o libiberty/getruntime.o
  ararm r libbinu.a libiberty/xatexit.o libiberty/concat.o
  ararm r libbinu.a libiberty/alloca.o libiberty/strdup.o libiberty/snprintf.o libiberty/vsnprintf.o
  ararm r libbinu.a gas/ecoff.o
  ararm r libbinu.a bfd/bfd.o bfd/hash.o bfd/bfdio.o bfd/cache.o bfd/libbfd.o bfd/opncls.o
  ararm r libbinu.a bfd/section.o bfd/format.o bfd/binary.o bfd/syms.o bfd/reloc.o bfd/linker.o
  ararm r libbinu.a bfd/archures.o bfd/archive.o bfd/targets.o
  ararm r libbinu.a bfd/stab-syms.o bfd/ihex.o bfd/tekhex.o bfd/srec.o
  ararm r libbinu.a bfd/init.o
  ararm r libbinu.a unixio.o
  ararm r libbinu.a gas/config/tc-arm.o
  ararm r libbinu.a bfd/cpu-arm.o
  ararm r libbinu.a bfd/aout32.o
  ararm r libbinu.a bfd/aout-arm.o
  ararm r libbinu.a gas/config/obj-aout.o
  ldarm -s -N -e ___crt0 -o as-pdos.exe ../pdos/pdpclib/pgastart.o gas/as.o gas/hash.o ./libbinu.a ../pdos/pdpclib/string.o ../pdos/pdpclib/armsupa.o

ld-pdos.exe: ld/ldmain.o ld/ldmisc.o ld/ldlex.o ld/ldfile.o \
    ld/ldgram.o ld/ldlang.o ld/ldexp.o ld/ldemul.o \
    ld/ldctor.o ld/mri.o ld/lexsup.o \
    ld/ldver.o ld/ldcref.o ld/ldwrite.o \
    libiberty/xstrdup.o libiberty/xmalloc.o libiberty/xexit.o \
    libiberty/cplus-dem.o libiberty/safe-ctype.o libiberty/cp-demangle.o \
    libiberty/dyn-string.o libiberty/strdup.o libiberty/strcasecmp.o \
    libiberty/strncasecmp.o libiberty/objalloc.o libiberty/concat.o \
    libiberty/fnmatch.o libiberty/hex.o libiberty/xstrerror.o \
    libiberty/obstack.o libiberty/getopt.o libiberty/getopt1.o \
    libiberty/make-relative-prefix.o libiberty/lbasename.o \
    libiberty/getruntime.o libiberty/xatexit.o libiberty/lrealpath.o \
    libiberty/alloca.o libiberty/snprintf.o libiberty/vsnprintf.o \
    libiberty/vasprintf.o \
    bfd/bfd.o bfd/linker.o bfd/archures.o bfd/libbfd.o \
    bfd/bfdio.o bfd/cache.o bfd/section.o \
    bfd/hash.o bfd/opncls.o bfd/reloc.o bfd/syms.o \
    bfd/format.o bfd/binary.o bfd/archive.o bfd/targets.o \
    bfd/aout32.o bfd/stab-syms.o bfd/ihex.o \
    bfd/tekhex.o bfd/srec.o bfd/init.o \
    unixio.o \
    bfd/cpu-arm.o \
    bfd/aout32.o \
    bfd/aout-arm.o \
    ld/earmaoutl.o
  rm -f libbinu.a
  ararm r libbinu.a ld/ldmisc.o ld/ldlex.o ld/ldfile.o
  ararm r libbinu.a ld/ldgram.o ld/ldlang.o ld/ldexp.o ld/ldemul.o
  ararm r libbinu.a ld/ldctor.o ld/mri.o ld/lexsup.o
  ararm r libbinu.a ld/ldver.o ld/ldcref.o ld/ldwrite.o
  ararm r libbinu.a libiberty/xstrdup.o libiberty/xmalloc.o libiberty/xexit.o
  ararm r libbinu.a libiberty/cplus-dem.o libiberty/safe-ctype.o libiberty/cp-demangle.o
  ararm r libbinu.a libiberty/dyn-string.o libiberty/strdup.o libiberty/strcasecmp.o
  ararm r libbinu.a libiberty/strncasecmp.o libiberty/objalloc.o libiberty/concat.o
  ararm r libbinu.a libiberty/fnmatch.o libiberty/hex.o libiberty/xstrerror.o
  ararm r libbinu.a libiberty/obstack.o libiberty/getopt.o libiberty/getopt1.o
  ararm r libbinu.a libiberty/make-relative-prefix.o libiberty/lbasename.o
  ararm r libbinu.a libiberty/getruntime.o libiberty/xatexit.o libiberty/lrealpath.o
  ararm r libbinu.a libiberty/alloca.o libiberty/snprintf.o libiberty/vsnprintf.o
  ararm r libbinu.a libiberty/vasprintf.o
  ararm r libbinu.a bfd/bfd.o bfd/linker.o bfd/archures.o bfd/libbfd.o
  ararm r libbinu.a bfd/bfdio.o bfd/cache.o bfd/section.o
  ararm r libbinu.a bfd/hash.o bfd/opncls.o bfd/reloc.o bfd/syms.o
  ararm r libbinu.a bfd/format.o bfd/binary.o bfd/archive.o bfd/targets.o
  ararm r libbinu.a bfd/aout32.o bfd/stab-syms.o bfd/ihex.o
  ararm r libbinu.a bfd/tekhex.o bfd/srec.o bfd/init.o
  ararm r libbinu.a unixio.o
  ararm r libbinu.a bfd/cpu-arm.o
  ararm r libbinu.a bfd/aout32.o
  ararm r libbinu.a bfd/aout-arm.o
  ararm r libbinu.a ld/earmaoutl.o
  ldarm -s -N -e ___crt0 -o ld-pdos.exe ../pdos/pdpclib/pgastart.o ld/ldmain.o ./libbinu.a ../pdos/pdpclib/string.o ../pdos/pdpclib/armsupa.o

ar-pdos.exe: binutils/ar.o binutils/arparse.o binutils/arlex.o \
    binutils/arsup.o binutils/bucomm.o binutils/filemode.o \
    binutils/binemul.o binutils/emul_vanilla.o binutils/not-ranlib.o \
    binutils/version.o binutils/rename.o \
    libiberty/xstrdup.o libiberty/xmalloc.o libiberty/xexit.o \
    libiberty/lbasename.o libiberty/objalloc.o libiberty/strcasecmp.o \
    libiberty/strncasecmp.o libiberty/safe-ctype.o libiberty/fnmatch.o \
    libiberty/hex.o libiberty/xstrerror.o libiberty/make-temp-file.o \
    libiberty/mkstemps.o libiberty/xatexit.o \
    libiberty/snprintf.o libiberty/vsnprintf.o libiberty/vasprintf.o \
    libiberty/alloca.o \
    bfd/opncls.o bfd/format.o bfd/archive.o bfd/libbfd.o bfd/bfd.o \
    bfd/bfdio.o bfd/cache.o bfd/section.o bfd/hash.o bfd/archures.o \
    bfd/binary.o bfd/syms.o bfd/reloc.o bfd/linker.o \
    bfd/targets.o bfd/aout32.o bfd/stab-syms.o bfd/ihex.o \
    bfd/tekhex.o bfd/srec.o bfd/init.o \
    unixio.o \
    bfd/cpu-arm.o \
    bfd/aout-arm.o
  rm -f libbinu.a
  ararm r libbinu.a binutils/arparse.o binutils/arlex.o
  ararm r libbinu.a binutils/arsup.o binutils/bucomm.o binutils/filemode.o
  ararm r libbinu.a binutils/binemul.o binutils/emul_vanilla.o binutils/not-ranlib.o
  ararm r libbinu.a binutils/version.o binutils/rename.o
  ararm r libbinu.a libiberty/xstrdup.o libiberty/xmalloc.o libiberty/xexit.o
  ararm r libbinu.a libiberty/lbasename.o libiberty/objalloc.o libiberty/strcasecmp.o
  ararm r libbinu.a libiberty/strncasecmp.o libiberty/safe-ctype.o libiberty/fnmatch.o
  ararm r libbinu.a libiberty/hex.o libiberty/xstrerror.o libiberty/make-temp-file.o
  ararm r libbinu.a libiberty/mkstemps.o libiberty/xatexit.o
  ararm r libbinu.a libiberty/snprintf.o libiberty/vsnprintf.o libiberty/vasprintf.o
  ararm r libbinu.a libiberty/alloca.o
  ararm r libbinu.a bfd/opncls.o bfd/format.o bfd/archive.o bfd/libbfd.o bfd/bfd.o
  ararm r libbinu.a bfd/bfdio.o bfd/cache.o bfd/section.o bfd/hash.o bfd/archures.o
  ararm r libbinu.a bfd/binary.o bfd/syms.o bfd/reloc.o bfd/linker.o
  ararm r libbinu.a bfd/targets.o bfd/aout32.o bfd/stab-syms.o bfd/ihex.o
  ararm r libbinu.a bfd/tekhex.o bfd/srec.o bfd/init.o
  ararm r libbinu.a unixio.o
  ararm r libbinu.a bfd/cpu-arm.o
  ararm r libbinu.a bfd/aout-arm.o
  ldarm -s -N -e ___crt0 -o ar-pdos.exe ../pdos/pdpclib/pgastart.o binutils/ar.o ./libbinu.a ../pdos/pdpclib/string.o ../pdos/pdpclib/armsupa.o

objdump-pdos.exe: binutils/objdump.o bfd/opncls.o libiberty/objalloc.o \
    unixio.o \
    bfd/bfd.o libiberty/xmalloc.o libiberty/xstrdup.o bfd/section.o \
    bfd/format.o bfd/archures.o bfd/libbfd.o bfd/bfdio.o bfd/cache.o \
    bfd/targets.o bfd/reloc.o bfd/linker.o bfd/hash.o \
    bfd/syms.o libiberty/safe-ctype.o bfd/archive.o bfd/aout32.o \
    bfd/stab-syms.o libiberty/fnmatch.o bfd/ihex.o libiberty/hex.o \
    bfd/binary.o bfd/tekhex.o bfd/srec.o libiberty/xexit.o \
    libiberty/xstrerror.o libiberty/strcasecmp.o libiberty/strncasecmp.o \
    binutils/bucomm.o binutils/filemode.o \
    libiberty/make-temp-file.o libiberty/mkstemps.o libiberty/getopt.o \
    binutils/version.o libiberty/cplus-dem.o libiberty/cp-demangle.o \
    libiberty/dyn-string.o libiberty/strdup.o libiberty/getopt1.o \
    bfd/init.o binutils/budemang.o binutils/prdbg.o binutils/debug.o \
    binutils/rddbg.o binutils/ieee.o binutils/stabs.o libiberty/concat.o \
    binutils/rdcoff.o bfd/coffgen.o bfd/dwarf2.o bfd/simple.o \
    opcodes/disassemble.o opcodes/dis-buf.o libiberty/vasprintf.o \
    libiberty/snprintf.o libiberty/vsnprintf.o libiberty/alloca.o \
    bfd/aout-arm.o \
    bfd/cpu-arm.o
  rm -f libbinu.a
  ararm r libbinu.a bfd/opncls.o libiberty/objalloc.o
  ararm r libbinu.a unixio.o
  ararm r libbinu.a bfd/bfd.o libiberty/xmalloc.o libiberty/xstrdup.o bfd/section.o
  ararm r libbinu.a bfd/format.o bfd/archures.o bfd/libbfd.o bfd/bfdio.o bfd/cache.o
  ararm r libbinu.a bfd/targets.o bfd/reloc.o bfd/linker.o bfd/hash.o
  ararm r libbinu.a bfd/syms.o libiberty/safe-ctype.o bfd/archive.o bfd/aout32.o
  ararm r libbinu.a bfd/stab-syms.o libiberty/fnmatch.o bfd/ihex.o libiberty/hex.o
  ararm r libbinu.a bfd/binary.o bfd/tekhex.o bfd/srec.o libiberty/xexit.o
  ararm r libbinu.a libiberty/xstrerror.o libiberty/strcasecmp.o libiberty/strncasecmp.o
  ararm r libbinu.a binutils/bucomm.o binutils/filemode.o
  ararm r libbinu.a libiberty/make-temp-file.o libiberty/mkstemps.o libiberty/getopt.o
  ararm r libbinu.a binutils/version.o libiberty/cplus-dem.o libiberty/cp-demangle.o
  ararm r libbinu.a libiberty/dyn-string.o libiberty/strdup.o libiberty/getopt1.o
  ararm r libbinu.a bfd/init.o binutils/budemang.o binutils/prdbg.o binutils/debug.o
  ararm r libbinu.a binutils/rddbg.o binutils/ieee.o binutils/stabs.o libiberty/concat.o
  ararm r libbinu.a binutils/rdcoff.o bfd/coffgen.o bfd/dwarf2.o bfd/simple.o
  ararm r libbinu.a opcodes/disassemble.o opcodes/dis-buf.o libiberty/vasprintf.o
  ararm r libbinu.a libiberty/snprintf.o libiberty/vsnprintf.o libiberty/alloca.o
  ararm r libbinu.a bfd/aout-arm.o bfd/cpu-arm.o
  ldarm -s -N -e ___crt0 -o objdump-pdos.exe ../pdos/pdpclib/pgastart.o binutils/objdump.o ./libbinu.a ../pdos/pdpclib/string.o ../pdos/pdpclib/armsupa.o

.c.o:
  $(CC) $(COPTS) -o $*.s $<
  asarm -o $@ $*.s
  rm -f $*.s

clean:
  rm -f */*/*.o
  rm -f */*.o
  rm -f *.o
