@ECHO off

SETLOCAL

SET cur_path=%cd%

IF "%1" == "" (
        GOTO:help
) ELSE (
        IF "%1" == "all" (
                SET target=%1
        ) ELSE (
                SET target=%1.exe 
        )
)

IF "%2" == "" (
        set mode=release
) ELSE (
        set mode=debug
)
GOTO:build

:help
        ECHO Usage: build.bat target mode
        ECHO - target: all, strip-pdos, ar-pdos, ld-pdos, as-pdos, dlltool-pdos. Default all target
        ECHO - mode: debug, release. Default release mode
        ECHO Example: 
        ECHO    'build.bat ar-pdos debug'
        ECHO    'build.bat ar-pdos'
        GOTO:EOF


:build
IF "%mode%" == "debug" (
        ECHO Build debug
        SET CFLAGS=-g3 -O0
        SET LD=ld
        SET LDFLAGS=
        SET AS=as
        SET AR=ar
        
) ELSE (
        ECHO Build release
        SET CFLAGS=-Os
        SET LD=ldwin
        SET LDFLAGS=-s
        SET AS=aswin
        SET AR=arwin
)

CD %cur_path%\..\pdos\src
CALL compk32.bat

CD %cur_path%\..\pdos\pdpclib
dmake -B -E CFLAGS="%CFLAGS%" -f makefile.w32

CD %cur_path%
dmake -B -E CFLAGS="%CFLAGS%" LDFLAGS="%LDFLAGS%" LD="%LD%" AS="%AS%" AR="%AR%" -f makefile.w32 clean %target%

GOTO:EOF