/* This file is is generated by a shell script.  DO NOT EDIT! */

/* emulate the original gld for the given armaoutl
   Copyright 1991, 1992, 1994, 1996, 2000, 2001, 2002
   Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

This file is part of GLD, the Gnu Linker.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#define TARGET_IS_armaoutl

#include "bfd.h"
#include "sysdep.h"
#include "bfdlink.h"

#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"

#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"

static void gldarmaoutl_before_parse PARAMS ((void));
static char *gldarmaoutl_get_script PARAMS ((int *isfile));


static void
gldarmaoutl_before_parse()
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("arm");
#endif /* not TARGET_ */
}


static char *
gldarmaoutl_get_script(isfile)
     int *isfile;
{			     
  *isfile = 0;

  if (link_info.relocateable && config.build_constructors)
    return
"/* Script for ld -Ur: link w/out relocation, do create constructors */\n\
OUTPUT_FORMAT(\"a.out-arm-little\")\n\
OUTPUT_ARCH(arm)\n\
SECTIONS\n\
{\n\
  .text    :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data  :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
  }\n\
  .bss  :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n\
   ;\n\
   ;\n\
  }\n\
}\n\n"
  ; else if (link_info.relocateable) return
"/* Script for ld -r: link without relocation */\n\
OUTPUT_FORMAT(\"a.out-arm-little\")\n\
OUTPUT_ARCH(arm)\n\
SECTIONS\n\
{\n\
  .text    :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data  :\n\
  {\n\
    *(.data)\n\
  }\n\
  .bss  :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n\
   ;\n\
   ;\n\
  }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N: mix text and data on same page; don't align data */\n\
OUTPUT_FORMAT(\"a.out-arm-little\")\n\
OUTPUT_ARCH(arm)\n\
SEARCH_DIR(\"=/usr/local/lib\"); SEARCH_DIR(\"=/lib\"); SEARCH_DIR(\"=/usr/lib\");\n\
SECTIONS\n\
{\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    __stext_ = .;\n\
    *(.text)\n\
    _etext = .;\n\
    __etext = .;\n\
  }\n\
  .data . :\n\
  {\n\
    __sdata_ = .;\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n\
    __edata  =  .;\n\
  }\n\
  .bss . :\n\
  {\n\
    __bss_start = .;\n"
"   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
  }\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n: mix text and data on same page */\n\
OUTPUT_FORMAT(\"a.out-arm-little\")\n\
OUTPUT_ARCH(arm)\n\
SEARCH_DIR(\"=/usr/local/lib\"); SEARCH_DIR(\"=/lib\"); SEARCH_DIR(\"=/usr/lib\");\n\
SECTIONS\n\
{\n\
  .text   0x8000 :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    __stext_ = .;\n\
    *(.text)\n\
    _etext = ALIGN(32768);\n\
    __etext = ALIGN(32768);\n\
  }\n\
  .data ALIGN(32768) :\n\
  {\n\
    __sdata_ = .;\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  ALIGN(32768);\n\
    __edata  =  ALIGN(32768);\n\
  }\n\
  .bss ALIGN(32768) :\n\
  {\n\
    __bss_start = .;\n"
"   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
  }\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
OUTPUT_FORMAT(\"a.out-arm-little\")\n\
OUTPUT_ARCH(arm)\n\
SEARCH_DIR(\"=/usr/local/lib\"); SEARCH_DIR(\"=/lib\"); SEARCH_DIR(\"=/usr/lib\");\n\
SECTIONS\n\
{\n\
  .text   0x8000 :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    __stext_ = .;\n\
    *(.text)\n\
    _etext = ALIGN(32768);\n\
    __etext = ALIGN(32768);\n\
  }\n\
  .data ALIGN(32768) :\n\
  {\n\
    __sdata_ = .;\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  ALIGN(32768);\n\
    __edata  =  ALIGN(32768);\n\
  }\n\
  .bss ALIGN(32768) :\n\
  {\n\
    __bss_start = .;\n"
"   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
  }\n\
}\n\n"
; }

struct ld_emulation_xfer_struct ld_armaoutl_emulation = 
{
  gldarmaoutl_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  after_open_default,
  after_allocation_default,
  set_output_arch_default,
  ldemul_default_target,
  before_allocation_default,
  gldarmaoutl_get_script,
  "armaoutl",
  "a.out-arm-little",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,	/* add_options */
  NULL,	/* handle_option */
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
