# This is the makefile for Win32 to build CVS using GCC

CC=gccwin
CFLAGS=-O2
COPTS=-S $(CFLAGS) -fno-common -I. -Ilib -Iwindows-NT -DPUREISO -DHAVE_CONFIG_H -I../pdos/pdpclib -Isrc -Idiff -I../pdos/src -DWIN32 -D__WIN32__
AS=pdas
AR=ar
LD=pdld

INTDIR=src
NTDIR=Windows-NT
LIBDIR=lib
DIFFDIR=diff

OBJS= \
	$(INTDIR)/add.obj \
	$(INTDIR)/admin.obj \
	$(INTDIR)/annotate.obj \
	$(INTDIR)/buffer.obj \
	$(INTDIR)/checkin.obj \
	$(INTDIR)/checkout.obj \
	$(INTDIR)/classify.obj \
	$(INTDIR)/client.obj \
	$(INTDIR)/commit.obj \
	$(INTDIR)/create_adm.obj \
	$(INTDIR)/cvsrc.obj \
	$(INTDIR)/diff.obj \
	$(INTDIR)/edit.obj \
	$(INTDIR)/entries.obj \
	$(INTDIR)/error.obj \
	$(INTDIR)/expand_path.obj \
	$(INTDIR)/fileattr.obj \
	$(NTDIR)/filesubr.obj \
	$(INTDIR)/find_names.obj \
	$(INTDIR)/hash.obj \
	$(INTDIR)/history.obj \
	$(INTDIR)/ignore.obj \
	$(INTDIR)/import.obj \
	$(INTDIR)/lock.obj \
	$(INTDIR)/log.obj \
	$(INTDIR)/logmsg.obj \
	$(INTDIR)/main.obj \
	$(NTDIR)/mkdir.obj \
	$(INTDIR)/mkmodules.obj \
	$(INTDIR)/modules.obj \
	$(INTDIR)/myndbm.obj \
	$(INTDIR)/no_diff.obj \
	$(INTDIR)/parseinfo.obj \
	$(INTDIR)/patch.obj \
	$(NTDIR)/pwd.obj \
	$(INTDIR)/rcs.obj \
	$(INTDIR)/rcscmds.obj \
	$(INTDIR)/recurse.obj \
	$(INTDIR)/release.obj \
	$(INTDIR)/remove.obj \
	$(INTDIR)/repos.obj \
	$(INTDIR)/root.obj \
	$(NTDIR)/run.obj \
	$(INTDIR)/scramble.obj \
	$(INTDIR)/server.obj \
	$(INTDIR)/stack.obj \
	$(INTDIR)/status.obj \
	$(INTDIR)/subr.obj \
	$(INTDIR)/tag.obj \
	$(INTDIR)/update.obj \
	$(INTDIR)/vers_ts.obj \
	$(INTDIR)/version.obj \
	$(INTDIR)/watch.obj \
	$(INTDIR)/wrapper.obj \
	$(INTDIR)/zlib.obj \
	$(LIBDIR)/argmatch.obj \
	$(LIBDIR)/fncase.obj \
	$(LIBDIR)/fnmatch.obj \
	$(LIBDIR)/getdate.obj \
	$(LIBDIR)/getline.obj \
	$(LIBDIR)/getopt.obj \
	$(LIBDIR)/getopt1.obj \
	$(LIBDIR)/md5.obj \
	$(LIBDIR)/regex.obj \
	$(LIBDIR)/savecwd.obj \
	$(LIBDIR)/sighandle.obj \
	$(LIBDIR)/stripslash.obj \
	$(LIBDIR)/valloc.obj \
	$(LIBDIR)/xgetwd.obj \
	$(LIBDIR)/yesno.obj \
	$(DIFFDIR)/analyze.obj \
	$(DIFFDIR)/cmpbuf.obj \
	$(DIFFDIR)/context.obj \
	$(DIFFDIR)/diff.obj \
	$(DIFFDIR)/diff3.obj \
	$(DIFFDIR)/dir.obj \
	$(DIFFDIR)/ed.obj \
	$(DIFFDIR)/ifdef.obj \
	$(DIFFDIR)/io.obj \
	$(DIFFDIR)/normal.obj \
	$(DIFFDIR)/side.obj \
	$(DIFFDIR)/util.obj \
	$(DIFFDIR)/version.obj \
        unixio.obj \
	$(NTDIR)/ndir.obj \
        ../pdos/pdpclib/winsupa.obj

UNUSED=	$(INTDIR)/login.obj \
	$(INTDIR)/sockerror.obj \
	$(INTDIR)/startserver.obj


all: clean cvs-new.exe

cvs-new.exe: $(OBJS)
  $(AR) s cvslib.lib
  $(LD) -s -nostdlib --no-insert-timestamp -o $@ ../pdos/pdpclib/w32start.obj $(INTDIR)/main.obj $(DIFFDIR)/diff.obj $(DIFFDIR)/version.obj cvslib.lib ../pdos/pdpclib/msvcrt.lib ../pdos/src/kernel32.lib ../pdos/pdpclib/winsupa.obj

.c.obj:
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ --oformat coff $*.s
  rm -f $*.s
  $(AR) r cvslib.lib $@

diff/diff.obj: diff/diff.c
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ --oformat coff $*.s
  rm -f $*.s

diff/version.obj: diff/version.c
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ --oformat coff $*.s
  rm -f $*.s

.asm.obj:
  as86 -f coff -o $@ $<

clean:
  rm -f *.obj
  rm -f cvs-new.exe
  rm -f cvslib.lib
