# This is the makefile for Win32 to build CVS using
# Open Watcom

CC=wcl386
CFLAGS=-oneatx
# Don't use -ecc because we call Watcom's qsort which is
# expecting its own calling convention
COPTS=-c $(CFLAGS) -fpi87 -q -Ilib -Iwindows-NT -DHAVE_CONFIG_H -I\watcom\h -I\watcom\h\nt -Isrc -Idiff -DWIN32 -DWATCOM

INTDIR=src
NTDIR=Windows-NT
LIBDIR=lib
DIFFDIR=diff

OBJS= \
	$(INTDIR)\add.obj \
	$(INTDIR)\admin.obj \
	$(INTDIR)\annotate.obj \
	$(INTDIR)\buffer.obj \
	$(INTDIR)\checkin.obj \
	$(INTDIR)\checkout.obj \
	$(INTDIR)\classify.obj \
	$(INTDIR)\client.obj \
	$(INTDIR)\commit.obj \
	$(INTDIR)\create_adm.obj \
	$(INTDIR)\cvsrc.obj \
	$(INTDIR)\diff.obj \
	$(INTDIR)\edit.obj \
	$(INTDIR)\entries.obj \
	$(INTDIR)\error.obj \
	$(INTDIR)\expand_path.obj \
	$(INTDIR)\fileattr.obj \
	$(NTDIR)\filesubr.obj \
	$(INTDIR)\find_names.obj \
	$(INTDIR)\hash.obj \
	$(INTDIR)\history.obj \
	$(INTDIR)\ignore.obj \
	$(INTDIR)\import.obj \
	$(INTDIR)\lock.obj \
	$(INTDIR)\log.obj \
	$(INTDIR)\logmsg.obj \
	$(INTDIR)\main.obj \
	$(NTDIR)\mkdir.obj \
	$(INTDIR)\mkmodules.obj \
	$(INTDIR)\modules.obj \
	$(INTDIR)\myndbm.obj \
	$(INTDIR)\no_diff.obj \
	$(INTDIR)\parseinfo.obj \
	$(INTDIR)\patch.obj \
	$(NTDIR)\pwd.obj \
	$(NTDIR)\rcmd.obj \
	$(INTDIR)\rcs.obj \
	$(INTDIR)\rcscmds.obj \
	$(INTDIR)\recurse.obj \
	$(INTDIR)\release.obj \
	$(INTDIR)\remove.obj \
	$(INTDIR)\repos.obj \
	$(INTDIR)\root.obj \
	$(NTDIR)\run.obj \
	$(INTDIR)\scramble.obj \
	$(INTDIR)\server.obj \
	$(INTDIR)\stack.obj \
	$(INTDIR)\status.obj \
	$(INTDIR)\subr.obj \
	$(INTDIR)\tag.obj \
	$(INTDIR)\update.obj \
	$(INTDIR)\vers_ts.obj \
	$(INTDIR)\version.obj \
	$(NTDIR)\waitpid.obj \
	$(INTDIR)\watch.obj \
	$(NTDIR)\woe32.obj \
	$(INTDIR)\wrapper.obj \
	$(INTDIR)\zlib.obj \
	$(LIBDIR)\argmatch.obj \
	$(LIBDIR)\fncase.obj \
	$(LIBDIR)\fnmatch.obj \
	$(LIBDIR)\getdate.obj \
	$(LIBDIR)\getline.obj \
	$(LIBDIR)\getopt.obj \
	$(LIBDIR)\getopt1.obj \
	$(LIBDIR)\md5.obj \
	$(LIBDIR)\regex.obj \
	$(LIBDIR)\savecwd.obj \
	$(LIBDIR)\sighandle.obj \
	$(LIBDIR)\stripslash.obj \
	$(LIBDIR)\valloc.obj \
	$(LIBDIR)\xgetwd.obj \
	$(LIBDIR)\yesno.obj \
	$(DIFFDIR)\analyze.obj \
	$(DIFFDIR)\cmpbuf.obj \
	$(DIFFDIR)\context.obj \
	$(DIFFDIR)\diff.obj \
	$(DIFFDIR)\diff3.obj \
	$(DIFFDIR)\dir.obj \
	$(DIFFDIR)\ed.obj \
	$(DIFFDIR)\ifdef.obj \
	$(DIFFDIR)\io.obj \
	$(DIFFDIR)\normal.obj \
	$(DIFFDIR)\side.obj \
	$(DIFFDIR)\util.obj \
	$(DIFFDIR)\version.obj

UNUSED=	$(INTDIR)\login.obj \
	$(INTDIR)\sockerror.obj \
	$(INTDIR)\startserver.obj \
	$(INTDIR)\ndir.obj


all: clean cvs-new.exe

cvs-new.exe: $(OBJS)
   wcl386 -q -fe=cvs-new.exe $(INTDIR)\main.obj watcomw.lib
#  wlink File $(INTDIR)\main.obj Name cvs-new.exe Form windows nt Runtime con Library watcomw.lib Option quiet

.c.obj:
  $(CC) $(COPTS) -fo=$@ $<
  wlib -b -q watcomw.lib +$@

clean:
  rm -f *.obj
  rm -f cvs-new.exe
  rm -f watcomw.lib
