# Produce a.out ARM executables for a PDOS-generic system
# Note that PDPCLIB must have been built using makefile.aga

CC=gccarm
COPTS=-msoft-float -fno-builtin -fno-common -O0 -D__UNOPT__ -mapcs-32 -S -D__PDOS386__ -D__PDOSGEN__ -D__ARMGEN__ -D__NOBIVA__ -DBUILDARM -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/generic -I ../../pdos/pdpclib -I ../../pdos/src -I . -I config/arm -I config -I ../include

all: clean gcc-new.exe

gcc-new.exe: \
    alias.o \
    attribs.o \
    bb-reorder.o \
    bitmap.o \
    builtins.o \
    c-aux-info.o \
    c-common.o \
    c-convert.o \
    c-decl.o \
    c-errors.o \
    c-format.o \
    c-lang.o \
    c-lex.o \
    c-objc-common.o \
    c-parse.o \
    c-pragma.o \
    c-semantics.o \
    c-typeck.o \
    caller-save.o \
    calls.o \
    cfg.o \
    cfganal.o \
    cfgbuild.o \
    cfgcleanup.o \
    cfglayout.o \
    cfgloop.o \
    cfgrtl.o \
    combine.o \
    conflict.o \
    convert.o \
    cppdefault.o \
    cpperror.o \
    cppexp.o \
    cppfiles.o \
    cpphash.o \
    cppinit.o \
    cpplex.o \
    cpplib.o \
    cppmacro.o \
    cppmain.o \
    cppspec.o \
    cse.o \
    cselib.o \
    debug.o \
    dependence.o \
    df.o \
    diagnostic.o \
    dominance.o \
    dwarf2asm.o \
    dwarf2out.o \
    emit-rtl.o \
    except.o \
    explow.o \
    expmed.o \
    expr.o \
    final.o \
    flow.o \
    fold-const.o \
    function.o \
    gcc.o \
    gccspec.o \
    gcse.o \
    genrtl.o \
    ggc-common.o \
    ggc-page.o \
    global.o \
    graph.o \
    hash.o \
    haifa-sched.o \
    hashtable.o \
    hooks.o \
    ifcvt.o \
    insn-attrtab.o \
    insn-emit.o \
    insn-extract.o \
    insn-opinit.o \
    insn-output.o \
    insn-peep.o \
    insn-recog.o \
    integrate.o \
    jump.o \
    langhooks.o \
    lcm.o \
    line-map.o \
    lists.o \
    local-alloc.o \
    loop.o \
    mkdeps.o \
    optabs.o \
    params.o \
    predict.o \
    prefix.o \
    print-rtl.o \
    print-tree.o \
    profile.o \
    real.o \
    recog.o \
    regclass.o \
    regmove.o \
    regrename.o \
    reload.o \
    reload1.o \
    resource.o \
    rtl-error.o \
    rtl.o \
    rtlanal.o \
    sbitmap.o \
    sched-deps.o \
    sched-rgn.o \
    sched-vis.o \
    sibcall.o \
    simplify-rtx.o \
    ssa-ccp.o \
    ssa-dce.o \
    ssa.o \
    stmt.o \
    stor-layout.o \
    stringpool.o \
    timevar.o \
    toplev.o \
    tree-dump.o \
    tree-inline.o \
    tree.o \
    unroll.o \
    varasm.o \
    varray.o \
    version.o \
    ../libiberty/xmalloc.o \
    ../libiberty/xstrerror.o \
    ../libiberty/xstrdup.o \
    ../libiberty/xexit.o \
    ../libiberty/concat.o \
    ../libiberty/hex.o \
    ../libiberty/alloca.o \
    ../libiberty/lbasename.o \
    ../libiberty/obstack.o \
    ../libiberty/strsignal.o \
    ../libiberty/safe-ctype.o \
    ../libiberty/splay-tree.o \
    ../libiberty/fibheap.o \
    ../libiberty/hashtab.o \
    ../libiberty/asprintf.o \
    ../libiberty/vasprintf.o \
    ../libiberty/getpagesize.o \
    ../libiberty/partition.o \
    config/arm/arm.o \
    unixio.o \
    reg-stack.o \
    doloop.o \
    sdbout.o \
    dbxout.o \
    ../libiberty/md5.o
  ldarm -s -N -e ___crt0 -o gcc-new.exe ../../pdos/pdpclib/pgastart.o temp.a ../../pdos/pdpclib/string.o ../../pdos/pdpclib/armsupa.o

.c.o:
  $(CC) $(COPTS) -o $*.s $<
  asarm -o $@ $*.s
  rm -f $*.s
  ararm r temp.a $*.o
  rm -f $*.o

clean:
  rm -f *.s
  rm -f *.o
  rm -f temp.a
  rm -f gcc-new.exe
