rem This is designed to work with PDPCLIB built with makefile.w32

rem set mdfile=./config/s390/s390.md
rem set EXTRAM="-DEXTRA_MODES_FILE=\"config/s390/s390-modes.def\""
set mdfile=./config/i370/i370.md

rm *.o

ren gencomp.exec gencomp.save
del gen*.exe
ren gencomp.save gencomp.exec

rm libiberty.a
rm autos.zip

zip -0 -m -@ -X autos.zip <genfiles.txt
unzip autos config.h auto-host.h tm.h tm_p.h specs.h options.c options.h multilib.h gtyp-gen.h gencheck.h gcov-iov.h configargs.h bconfig.h

echo #include "auto-host.h" >auto-build.h

call stdcompz ../libiberty/cplus-dem.c
call stdcompz ../libiberty/cp-demangle.c
call stdcompz ../libiberty/cp-demint.c
call stdcompz ../libiberty/md5.c
call stdcompz ../libiberty/alloca.c
call stdcompz ../libiberty/asprintf.c
call stdcompz ../libiberty/argv.c
call stdcompz ../libiberty/concat.c
call stdcompz ../libiberty/dyn-string.c
call stdcompz ../libiberty/fdmatch.c
call stdcompz ../libiberty/fibheap.c
call stdcompz ../libiberty/floatformat.c
call stdcompz ../libiberty/fnmatch.c
call stdcompz ../libiberty/getopt.c
call stdcompz ../libiberty/getopt1.c
call stdcompz ../libiberty/getpagesize.c
call stdcompz ../libiberty/getpwd.c
call stdcompz ../libiberty/getruntime.c
call stdcompz ../libiberty/hashtab.c
call stdcompz ../libiberty/hex.c
call stdcompz ../libiberty/lbasename.c
call stdcompz ../libiberty/lrealpath.c
call stdcompz ../libiberty/make-relative-prefix.c
call stdcompz ../libiberty/objalloc.c
call stdcompz ../libiberty/obstack.c
call stdcompz ../libiberty/partition.c
call stdcompz ../libiberty/physmem.c
call stdcompz ../libiberty/safe-ctype.c
call stdcompz ../libiberty/snprintf.c
call stdcompz ../libiberty/sort.c
call stdcompz ../libiberty/spaces.c
call stdcompz ../libiberty/splay-tree.c
call stdcompz ../libiberty/strcasecmp.c
call stdcompz ../libiberty/strdup.c
call stdcompz ../libiberty/strsignal.c
call stdcompz ../libiberty/ternary.c
call stdcompz ../libiberty/vasprintf.c
call stdcompz ../libiberty/vsnprintf.c
call stdcompz ../libiberty/xatexit.c
call stdcompz ../libiberty/xexit.c
call stdcompz ../libiberty/xmalloc.c
call stdcompz ../libiberty/xmemdup.c
call stdcompz ../libiberty/xstrdup.c
call stdcompz ../libiberty/xstrerror.c

ar rc libiberty.a *.o
ranlib libiberty.a


call stdcompz errors.c

call stdcompz genmodes.c %EXTRAM%
gcc -nostdlib -o genmodes genmodes.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc
genmodes -h >insn-modes.h
genmodes -m >min-insn-modes.c
genmodes >insn-modes.c

call stdcompz gengenrtl.c
gcc -nostdlib -o gengenrtl gengenrtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

gengenrtl -h >genrtl.h
gengenrtl >genrtl.c

call stdcompz genconstants.c

call stdcompz gengtype.c

call stdcompz gengtype-lex.c
echo bison  -d -o gengtype-yacc.c gengtype-yacc.y
call stdcompz gengtype-yacc.c

gcc -nostdlib -o gengtype gengtype.o gengtype-lex.o gengtype-yacc.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

rem filenames hardcoded
echo this program generates a few warnings - that is normal
gengtype

call stdcompz rtl.c
call stdcompz read-rtl.c
call stdcompz bitmap.c
call stdcompz ggc-none.c
call stdcompz min-insn-modes.c
call stdcompz gensupport.c
call stdcompz dummy-conditions.c

gcc -nostdlib -o genconstants genconstants.o gensupport.o dummy-conditions.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genconstants %mdfile% >insn-constants.h

call stdcompz genflags.c
call stdcompz genconditions.c

gcc -nostdlib -o genconditions genconditions.o gensupport.o dummy-conditions.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genconditions %mdfile% >insn-conditions.c

call stdcompz genpreds.c
gcc -nostdlib -o genpreds genpreds.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genpreds >tm-preds.h

call stdcompz insn-conditions.c

call stdcompz gencheck.c

gcc -nostdlib -o gencheck gencheck.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

gencheck >tree-check.h

call stdcompz print-rtl.c

gcc -nostdlib -o genflags genflags.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genflags %mdfile% >insn-flags.h

call stdcompz genconfig.c

gcc -nostdlib -o genconfig genconfig.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genconfig %mdfile% >insn-config.h

call stdcompz gencodes.c

gcc -nostdlib -o gengenrtl gengenrtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

gcc -nostdlib -o gencodes gencodes.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

gencodes %mdfile% >insn-codes.h

call stdcompz genattr.c

gcc -nostdlib -o genattr genattr.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genattr %mdfile% >insn-attr.h

call stdcompz ./gcov-iov.c

gcc -nostdlib -o gengenrtl gengenrtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

gcc -nostdlib -o gcov-iov gcov-iov.o ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc
rem gcov-iov >gcov-iov.h

call stdcompz genattrtab.c
call stdcompz genautomata.c
call stdcompz varray.c

gcc -nostdlib -o genattrtab genattrtab.o genautomata.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o varray.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genattrtab %mdfile% >insn-attrtab.c

call stdcompz genemit.c

gcc -nostdlib -o genemit genemit.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genemit %mdfile% >insn-emit.c

call stdcompz genextract.c

gcc -nostdlib -o genextract genextract.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genextract %mdfile% >insn-extract.c

call stdcompz genopinit.c

gcc -nostdlib -o genopinit genopinit.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genopinit %mdfile% >insn-opinit.c

call stdcompz genoutput.c

gcc -nostdlib -o genoutput genoutput.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genoutput %mdfile% >insn-output.c

call stdcompz genpeep.c

gcc -nostdlib -o genpeep genpeep.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genpeep %mdfile% >insn-peep.c

call stdcompz genrecog.c

gcc -nostdlib -o genrecog genrecog.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o gensupport.o insn-conditions.o print-rtl.o errors.o libiberty.a ../../pdos/pdpclib/pdpwin32.a -lkernel32 -lgcc

genrecog %mdfile% >insn-recog.c
