# Produce generated files

# PDPCLIB must have been built with makefile.p32
# We would normally use makefile.std, but there is
# a bug somewhere that when building mips on Windows 2000,
# memory address 38 is referenced when running genflags.
# To begin debugging that I need my own C library, and
# my own memory allocation routines so I can see what
# the application is doing. But switching just to my own
# C library made the problem go away. There are other
# ways to debug, but I haven't made the effort. There
# was a new bug elsewhere though, which I also wasn't
# able to quickly debug, so MIPS still doesn't work

MDFILE=./config/i370/i370.md
#MDFILE=./config/i386/i386.md
#MDFILE=./config/arm/arm.md
#MDFILE=./config/m68k/m68k.md
#MDFILE=./config/s390/s390.md
#MDFILE=./config/mips/mips.md

TARGET=I370
#TARGET=I386
#TARGET=BUILDARM
#TARGET=BUILDAMIGA
#TARGET=S390
#TARGET=BUILDMIPS

TDIR=i370
#TDIR=i386
#TDIR=arm
#TDIR=m68k
#TDIR=s390
#TDIR=mips

CC=gccwin
#AR=arwin
AR=xar
#AS=aswin
AS=pdas --oformat coff
#LD=ldwin
LD=pdld --no-insert-timestamp
COPTS=-DNO_DETAB -DGENERATOR_FILE -fno-common -O2 -S -D__WIN32__ \
    -D__STATIC__ \
    -D__NOBIVA__ -D$(TARGET) -DHAVE_CONFIG_H -DIN_GCC -DPUREISO \
    -I ../../pdos/pdpclib -I ../../pdos/src -I . -I config/$(TDIR) -I config -I ../include

#EXTRA1=../../pdos/pdpclib/w32start.o
EXTRA1=../../pdos/pdpclib/p32start.obj
#EXTRA1=../../pdos/pdpclib/w32start.obj

#EXTRA2=../../pdos/pdpclib/msvcrt.a
EXTRA2=../../pdos/pdpclib/pdpwin32.lib ../../pdos/src/kernel32.lib
#EXTRA2=../../pdos/pdpclib/msvcrt.lib

LIBIB=../libiberty/xmalloc.o ../libiberty/xstrerror.o ../libiberty/xstrdup.o \
  ../libiberty/xexit.o ../libiberty/concat.o ../libiberty/hex.o \
  ../libiberty/alloca.o ../libiberty/lbasename.o ../libiberty/obstack.o \
  ../libiberty/strsignal.o ../libiberty/safe-ctype.o ../libiberty/splay-tree.o \
  ../libiberty/fibheap.o ../libiberty/hashtab.o ../libiberty/asprintf.o \
  ../libiberty/vasprintf.o ../libiberty/getpagesize.o ../libiberty/partition.o


all: clean libiberty.a gengenrtl.exe gencheck.exe genflags.exe \
  genconstants.exe genpreds.exe genconfig.exe gencodes.exe genattr.exe \
  genattrtab.exe genemit.exe genextract.exe genopinit.exe \
  genoutput.exe genpeep.exe genrecog.exe

libiberty.a: $(LIBIB)
  $(AR) r libiberty.a $(LIBIB)
  $(AR) s libiberty.a

gengenrtl.exe: gengenrtl.o
  $(LD) -s -o gengenrtl.exe $(EXTRA1) gengenrtl.o libiberty.a $(EXTRA2)
  gengenrtl -h >genrtl.h
  gengenrtl >genrtl.c

gencheck.exe: gencheck.o
  $(LD) -s -o gencheck.exe $(EXTRA1) gencheck.o libiberty.a $(EXTRA2)
  gencheck >tree-check.h

genflags.exe: genflags.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -Map map.txt -s -o genflags.exe $(EXTRA1) genflags.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genflags $(MDFILE) >insn-flags.h

genconstants.exe: genconstants.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o errors.o
  $(LD) -s -o genconstants.exe $(EXTRA1) genconstants.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o errors.o libiberty.a $(EXTRA2)
  genconstants $(MDFILE) >insn-constants.h

genpreds.exe: genpreds.o
  $(LD) -s -o genpreds.exe $(EXTRA1) genpreds.o libiberty.a $(EXTRA2)
  genpreds >tm-preds.h

genconfig.exe: genconfig.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genconfig.exe $(EXTRA1) genconfig.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genconfig $(MDFILE) >insn-config.h

gencodes.exe: gencodes.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o gencodes.exe $(EXTRA1) gencodes.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  gencodes $(MDFILE) >insn-codes.h

genattr.exe: genattr.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genattr.exe $(EXTRA1) genattr.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genattr $(MDFILE) >insn-attr.h

genattrtab.exe: genattrtab.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genattrtab.exe $(EXTRA1) genattrtab.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genattrtab $(MDFILE) >insn-attrtab.c

genemit.exe: genemit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genemit.exe $(EXTRA1) genemit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genemit $(MDFILE) >insn-emit.c

genextract.exe: genextract.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genextract.exe $(EXTRA1) genextract.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genextract $(MDFILE) >insn-extract.c

genopinit.exe: genopinit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genopinit.exe $(EXTRA1) genopinit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genopinit $(MDFILE) >insn-opinit.c

genoutput.exe: genoutput.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genoutput.exe $(EXTRA1) genoutput.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genoutput $(MDFILE) >insn-output.c

genpeep.exe: genpeep.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genpeep.exe $(EXTRA1) genpeep.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genpeep $(MDFILE) >insn-peep.c

genrecog.exe: genrecog.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o
  $(LD) -s -o genrecog.exe $(EXTRA1) genrecog.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o libiberty.a $(EXTRA2)
  genrecog $(MDFILE) >insn-recog.c

.c.o:
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ $*.s
  rm -f $*.s

clean:
  rm -f *.s
  rm -f *.o
  rm -f libiberty.a
  rm -f gen*.exe
