# Produce generated files

# PDPCLIB must have been built with makefile.msv

MDFILE=./config/i370/i370.md
#MDFILE=./config/i386/i386.md
#MDFILE=./config/arm/arm.md
#MDFILE=./config/m68k/m68k.md
#MDFILE=./config/s390/s390.md

TARGET=I370
#TARGET=I386
#TARGET=BUILDARM
#TARGET=BUILDAMIGA
#TARGET=S390

TDIR=i370
#TDIR=i386
#TDIR=arm
#TDIR=m68k
#TDIR=s390

CC=gccwin
AR=arwin
COPTS=-DNO_DETAB -DGENERATOR_FILE -fno-common -O2 -S -D__WIN32__ -D__NOBIVA__ -D$(TARGET) -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I ../../pdos/src -I . -I config/$(TDIR) -I config -I ../include

LIBIB=../libiberty/xmalloc.o ../libiberty/xstrerror.o ../libiberty/xstrdup.o \
  ../libiberty/xexit.o ../libiberty/concat.o ../libiberty/hex.o \
  ../libiberty/alloca.o ../libiberty/lbasename.o ../libiberty/obstack.o \
  ../libiberty/strsignal.o ../libiberty/safe-ctype.o ../libiberty/splay-tree.o \
  ../libiberty/fibheap.o ../libiberty/hashtab.o ../libiberty/asprintf.o \
  ../libiberty/vasprintf.o ../libiberty/getpagesize.o ../libiberty/partition.o \
  ../libiberty/snprintf.o ../libiberty/vsnprintf.o ../libiberty/getruntime.o \
  ../libiberty/xmemdup.o


all: clean libiberty.a genmodes.exe gengenrtl.exe gengtype.exe \
  gencheck.exe genconstants.exe genconditions.exe \
  genpreds.exe genflags.exe genconfig.exe gencodes.exe genattr.exe \
  genattrtab.exe genemit.exe genextract.exe genopinit.exe \
  genoutput.exe genpeep.exe genrecog.exe

libiberty.a: $(LIBIB)
  $(AR) r libiberty.a $(LIBIB)

genmodes.exe: genmodes.o errors.o
  ldwin -s -o genmodes.exe ../../pdos/pdpclib/w32start.o genmodes.o errors.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genmodes -h >insn-modes.h
  genmodes -m >min-insn-modes.c
  genmodes >insn-modes.c

gengenrtl.exe: gengenrtl.o
  ldwin -s -o gengenrtl.exe ../../pdos/pdpclib/w32start.o gengenrtl.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  gengenrtl -h >genrtl.h
  gengenrtl >genrtl.c

# It is normal for this to generate some warnings
gengtype.exe: gengtype.o gengtype-lex.o gengtype-yacc.o
  ldwin -s -o gengtype.exe ../../pdos/pdpclib/w32start.o gengtype.o gengtype-lex.o gengtype-yacc.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  gengtype

gencheck.exe: gencheck.o
  ldwin -s -o gencheck.exe ../../pdos/pdpclib/w32start.o gencheck.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  gencheck >tree-check.h

genconstants.exe: genconstants.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o errors.o min-insn-modes.o dummy-conditions.o
  ldwin -s -o genconstants.exe ../../pdos/pdpclib/w32start.o genconstants.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o errors.o min-insn-modes.o dummy-conditions.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genconstants $(MDFILE) >insn-constants.h

genconditions.exe: genconditions.o gensupport.o dummy-conditions.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o errors.o
  ldwin -s -o genconditions.exe ../../pdos/pdpclib/w32start.o genconditions.o gensupport.o dummy-conditions.o rtl.o read-rtl.o bitmap.o ggc-none.o min-insn-modes.o errors.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genconditions $(MDFILE) >insn-conditions.c

genpreds.exe: genpreds.o
  ldwin -s -o genpreds.exe ../../pdos/pdpclib/w32start.o genpreds.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genpreds >tm-preds.h

genflags.exe: genflags.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o dummy-conditions.o min-insn-modes.o
  ldwin -s -o genflags.exe ../../pdos/pdpclib/w32start.o genflags.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o dummy-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genflags $(MDFILE) >insn-flags.h

genconfig.exe: genconfig.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genconfig.exe ../../pdos/pdpclib/w32start.o genconfig.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genconfig $(MDFILE) >insn-config.h

gencodes.exe: gencodes.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o
  ldwin -s -o gencodes.exe ../../pdos/pdpclib/w32start.o gencodes.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  gencodes $(MDFILE) >insn-codes.h

genattr.exe: genattr.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genattr.exe ../../pdos/pdpclib/w32start.o genattr.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genattr $(MDFILE) >insn-attr.h

genattrtab.exe: genattrtab.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o genautomata.o varray.o
  ldwin -s -o genattrtab.exe ../../pdos/pdpclib/w32start.o genattrtab.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o genautomata.o varray.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genattrtab $(MDFILE) >insn-attrtab.c

genemit.exe: genemit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o
  ldwin -s -o genemit.exe ../../pdos/pdpclib/w32start.o genemit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o min-insn-modes.o insn-conditions.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genemit $(MDFILE) >insn-emit.c

genextract.exe: genextract.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genextract.exe ../../pdos/pdpclib/w32start.o genextract.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genextract $(MDFILE) >insn-extract.c

genopinit.exe: genopinit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genopinit.exe ../../pdos/pdpclib/w32start.o genopinit.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genopinit $(MDFILE) >insn-opinit.c

genoutput.exe: genoutput.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genoutput.exe ../../pdos/pdpclib/w32start.o genoutput.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genoutput $(MDFILE) >insn-output.c

genpeep.exe: genpeep.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genpeep.exe ../../pdos/pdpclib/w32start.o genpeep.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genpeep $(MDFILE) >insn-peep.c

genrecog.exe: genrecog.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o
  ldwin -s -o genrecog.exe ../../pdos/pdpclib/w32start.o genrecog.o rtl.o read-rtl.o bitmap.o ggc-none.o gensupport.o print-rtl.o errors.o insn-conditions.o min-insn-modes.o libiberty.a ../../pdos/pdpclib/msvcrt.a
  genrecog $(MDFILE) >insn-recog.c

.c.o:
  $(CC) $(COPTS) -o $*.s $<
  aswin -o $@ $*.s
  rm -f $*.s

clean:
  rm -f *.s
  rm -f *.o
  rm -f libiberty.a
  rm -f gen*.exe
  zip -0 -m -@ -X autos.zip <genfiles.txt
  unzip autos config.h auto-host.h tm.h tm_p.h specs.h options.c options.h multilib.h gtyp-gen.h gencheck.h gcov-iov.h configargs.h bconfig.h
  echo #include "auto-host.h" >auto-build.h
