# Produce a Linux ELF executable

# Links with pdpclib created with makefile.l64 (if using gcc)
# or makefile.lx6 (if using gccx64)

# If using gccx64

# Change XMSABI to MSABI to target Win64 instead of Linux x64

# consider whether we should define VALIST_NOT_PTR
# somewhere else. We need this for 64-bit building
# because of the non-stack parameter passing.
# vasprintf.c in libiberty needs to know this.
# Might want to have something that works with
# stdio.c too.

# Note that __FORCE_ALL_64__ is for if this compiler
# is using the forced mode, while FORCE_ALL_64 is
# specific to this application (a compiler) which is
# telling it to build the all-64-bit model, which
# will match SubC

# Note that modern gcc doesn't allow me to build with
# optimization on for some reason (the executable that
# is produced crashes), but gcc 3.2.3 works (to some
# unknown extent).

CC=gcc -fno-stack-protector -D__USEBIVA__ -DVALIST_NOT_PTR -O0

#CC=gccx64 -D__FORCE_ALL_64 -D__NOBIVA__ -mregparm=0 -O0
#ENTRY=-e __start

COPTS=-DXHAVE_LONG_LONG -DTARGET_64BIT_DEFAULT \
    -DFORCE_ALL_64 \
    -U__WIN32__ -D__gnu_linux__ \
    -D__64BIT__ -DXMSABI -fno-common -S -fno-builtin \
    -D__NOBIVA__ -DI386 -DHAVE_CONFIG_H -DIN_GCC -DPUREISO \
    -I ../../pdos/pdpclib -I ../../pdos/src \
    -I . -I config/i386 -I config -I ../include

all: clean gcc-new.exe

gcc-new.exe: \
    alias.o \
    attribs.o \
    bb-reorder.o \
    bitmap.o \
    builtins.o \
    c-aux-info.o \
    c-common.o \
    c-convert.o \
    c-decl.o \
    c-errors.o \
    c-format.o \
    c-lang.o \
    c-lex.o \
    c-objc-common.o \
    c-parse.o \
    c-pragma.o \
    c-semantics.o \
    c-typeck.o \
    caller-save.o \
    calls.o \
    cfg.o \
    cfganal.o \
    cfgbuild.o \
    cfgcleanup.o \
    cfglayout.o \
    cfgloop.o \
    cfgrtl.o \
    combine.o \
    conflict.o \
    convert.o \
    cppdefault.o \
    cpperror.o \
    cppexp.o \
    cppfiles.o \
    cpphash.o \
    cppinit.o \
    cpplex.o \
    cpplib.o \
    cppmacro.o \
    cppmain.o \
    cppspec.o \
    cse.o \
    cselib.o \
    debug.o \
    dependence.o \
    df.o \
    diagnostic.o \
    dominance.o \
    dwarf2asm.o \
    dwarf2out.o \
    emit-rtl.o \
    except.o \
    explow.o \
    expmed.o \
    expr.o \
    final.o \
    flow.o \
    fold-const.o \
    function.o \
    gcc.o \
    gccspec.o \
    gcse.o \
    genrtl.o \
    ggc-common.o \
    ggc-page.o \
    global.o \
    graph.o \
    hash.o \
    haifa-sched.o \
    hashtable.o \
    hooks.o \
    ifcvt.o \
    insn-attrtab.o \
    insn-emit.o \
    insn-extract.o \
    insn-opinit.o \
    insn-output.o \
    insn-peep.o \
    insn-recog.o \
    integrate.o \
    jump.o \
    langhooks.o \
    lcm.o \
    line-map.o \
    lists.o \
    local-alloc.o \
    loop.o \
    mkdeps.o \
    optabs.o \
    params.o \
    predict.o \
    prefix.o \
    print-rtl.o \
    print-tree.o \
    profile.o \
    real.o \
    recog.o \
    regclass.o \
    regmove.o \
    regrename.o \
    reload.o \
    reload1.o \
    resource.o \
    rtl-error.o \
    rtl.o \
    rtlanal.o \
    sbitmap.o \
    sched-deps.o \
    sched-rgn.o \
    sched-vis.o \
    sibcall.o \
    simplify-rtx.o \
    ssa-ccp.o \
    ssa-dce.o \
    ssa.o \
    stmt.o \
    stor-layout.o \
    stringpool.o \
    timevar.o \
    toplev.o \
    tree-dump.o \
    tree-inline.o \
    tree.o \
    unroll.o \
    varasm.o \
    varray.o \
    version.o \
    ../libiberty/xmalloc.o \
    ../libiberty/xstrerror.o \
    ../libiberty/xstrdup.o \
    ../libiberty/xexit.o \
    ../libiberty/concat.o \
    ../libiberty/hex.o \
    ../libiberty/alloca.o \
    ../libiberty/lbasename.o \
    ../libiberty/obstack.o \
    ../libiberty/strsignal.o \
    ../libiberty/safe-ctype.o \
    ../libiberty/splay-tree.o \
    ../libiberty/fibheap.o \
    ../libiberty/hashtab.o \
    ../libiberty/asprintf.o \
    ../libiberty/vasprintf.o \
    ../libiberty/getpagesize.o \
    ../libiberty/partition.o \
    config/i386/i386.o \
    config/i386/winnt.o \
    unixio.o \
    reg-stack.o \
    doloop.o \
    sdbout.o \
    dbxout.o \
    ../libiberty/md5.o
  ar s temp.a
  ar x temp.a gcc.o
  ld -s -nostdlib $(ENTRY) -o gcc-new.exe ../../pdos/pdpclib/linstart.o gcc.o temp.a ../../pdos/pdpclib/pdplinux.a
  rm -f gcc.o

.c.o:
  $(CC) $(COPTS) -o $*.s $<
  as -o $@ $*.s
  rm -f $*.s
  ar r temp.a $*.o
  rm -f $*.o

clean:
  rm -f *.s
  rm -f *.o
  rm -f temp.a
  rm -f gcc-new.exe
