# Produce Windows executables that use MSVCRT.DLL
# To produce ARM assembler code
# Note that compile pe.c even for non-pe targets is harmless
# and convenient for when you want pe

# Note that you can use the ARM toolchain itself to produce
# a Windows ARM32 executable that targets ARM32

# This requires you to have run makefile.std first
CC=gccwin
AS=pdas --oformat coff
AR=xar

# The below requires you to have run makefile.war first
#CC=gccprm
#AS=asprm
#AR=arprm
#EXTRA=../../pdos/pdpclib/armsupa.obj ../../pdos/pdpclib/fpfuncsa.obj

LD=pdld --no-insert-timestamp

# This is for a.out executables
#COPTS=-fno-common -O2 -S -D__WIN32__ -D__NOBIVA__ -DBUILDARM -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I ../../pdos/src -I . -I config/arm -I config -I ../include
# This is for ELF executables
#COPTS=-fno-common -O2 -S -D__WIN32__ -D__NOBIVA__ -DBUILDERM -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -I config/arm -I config -I ../include -I ../../pdos/src
# This is for PE (and EFI) executables
COPTS=-fno-common -O2 -S -D__WIN32__ -D__NOBIVA__ -DBUILDPRM -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -I config/arm -I config -I ../include -I ../../pdos/src
# This is for ARM PE executables using gccprm
#COPTS=-D__ARM__ -msoft-float -mapcs-32 -fno-leading-underscore -fno-common -O0 -S -D__WIN32__ -D__USEBIVA__ -DBUILDPRM -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -I config/arm -I config -I ../include -I ../../pdos/src

all: clean gcc-new.exe

gcc-new.exe: \
    alias.obj \
    attribs.obj \
    bb-reorder.obj \
    bitmap.obj \
    builtins.obj \
    c-aux-info.obj \
    c-common.obj \
    c-convert.obj \
    c-decl.obj \
    c-errors.obj \
    c-format.obj \
    c-lang.obj \
    c-lex.obj \
    c-objc-common.obj \
    c-parse.obj \
    c-pragma.obj \
    c-semantics.obj \
    c-typeck.obj \
    caller-save.obj \
    calls.obj \
    cfg.obj \
    cfganal.obj \
    cfgbuild.obj \
    cfgcleanup.obj \
    cfglayout.obj \
    cfgloop.obj \
    cfgrtl.obj \
    combine.obj \
    conflict.obj \
    convert.obj \
    cppdefault.obj \
    cpperror.obj \
    cppexp.obj \
    cppfiles.obj \
    cpphash.obj \
    cppinit.obj \
    cpplex.obj \
    cpplib.obj \
    cppmacro.obj \
    cppmain.obj \
    cppspec.obj \
    cse.obj \
    cselib.obj \
    debug.obj \
    dependence.obj \
    df.obj \
    diagnostic.obj \
    dominance.obj \
    dwarf2asm.obj \
    dwarf2out.obj \
    emit-rtl.obj \
    except.obj \
    explow.obj \
    expmed.obj \
    expr.obj \
    final.obj \
    flow.obj \
    fold-const.obj \
    function.obj \
    gcc.obj \
    gccspec.obj \
    gcse.obj \
    genrtl.obj \
    ggc-common.obj \
    ggc-page.obj \
    global.obj \
    graph.obj \
    hash.obj \
    haifa-sched.obj \
    hashtable.obj \
    hooks.obj \
    ifcvt.obj \
    insn-attrtab.obj \
    insn-emit.obj \
    insn-extract.obj \
    insn-opinit.obj \
    insn-output.obj \
    insn-peep.obj \
    insn-recog.obj \
    integrate.obj \
    jump.obj \
    langhooks.obj \
    lcm.obj \
    line-map.obj \
    lists.obj \
    local-alloc.obj \
    loop.obj \
    mkdeps.obj \
    optabs.obj \
    params.obj \
    predict.obj \
    prefix.obj \
    print-rtl.obj \
    print-tree.obj \
    profile.obj \
    real.obj \
    recog.obj \
    regclass.obj \
    regmove.obj \
    regrename.obj \
    reload.obj \
    reload1.obj \
    resource.obj \
    rtl-error.obj \
    rtl.obj \
    rtlanal.obj \
    sbitmap.obj \
    sched-deps.obj \
    sched-rgn.obj \
    sched-vis.obj \
    sibcall.obj \
    simplify-rtx.obj \
    ssa-ccp.obj \
    ssa-dce.obj \
    ssa.obj \
    stmt.obj \
    stor-layout.obj \
    stringpool.obj \
    timevar.obj \
    toplev.obj \
    tree-dump.obj \
    tree-inline.obj \
    tree.obj \
    unroll.obj \
    varasm.obj \
    varray.obj \
    version.obj \
    ../libiberty/xmalloc.obj \
    ../libiberty/xstrerror.obj \
    ../libiberty/xstrdup.obj \
    ../libiberty/xexit.obj \
    ../libiberty/concat.obj \
    ../libiberty/hex.obj \
    ../libiberty/alloca.obj \
    ../libiberty/lbasename.obj \
    ../libiberty/obstack.obj \
    ../libiberty/strsignal.obj \
    ../libiberty/safe-ctype.obj \
    ../libiberty/splay-tree.obj \
    ../libiberty/fibheap.obj \
    ../libiberty/hashtab.obj \
    ../libiberty/asprintf.obj \
    ../libiberty/vasprintf.obj \
    ../libiberty/getpagesize.obj \
    ../libiberty/partition.obj \
    config/arm/arm.obj \
    config/arm/pe.obj \
    unixio.obj \
    reg-stack.obj \
    doloop.obj \
    sdbout.obj \
    dbxout.obj \
    ../libiberty/md5.obj
  $(AR) s temp.lib
  $(AR) x temp.lib gcc.obj
  $(LD) -nostdlib -s -o gcc-new.exe ../../pdos/pdpclib/w32start.obj gcc.obj temp.lib $(EXTRA) ../../pdos/pdpclib/msvcrt.lib
  rm -f gcc.obj

.c.obj:
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ $*.s
  rm -f $*.s
  $(AR) r temp.lib $*.obj
  rm -f $*.obj

clean:
  rm -f *.s
  rm -f *.obj
  rm -f temp.lib
  rm -f gcc-new.exe
