# Produce z/PDOS-generic executables to generate S/370 assembler
# makefile.zpg needs to have been run in pdpclib first

# We can't detab because we can't redefine the standard
# C90 functions - but nor do we need to, because this
# is meant to be temporary assembler for use by as370

# I think this has been superceded by win370.mak

CC=gcc370 -U__MVS__ -D__MF32__ -D__PDOSGEN__ -I../../pdos/generic \
   -I../../pdos/src -DNO_DETAB
AS=as370
AR=xar
LD=pdld --oformat mvs -e __crt0

# This is for MVS
#COPTS=-Os -S -fno-common -ansi -nostdinc -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -DI370 -D__NOBIVA__ -I config/i370 -I ../include
# This is for Linux
#COPTS=-DTARGET_LINUX -Os -S -fno-common -ansi -nostdinc -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -DI370 -D__NOBIVA__ -I config/i370 -I ../include
# This is for CMS
#COPTS=-DTARGET_CMS -Os -S -fno-common -ansi -nostdinc -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -DI370 -D__NOBIVA__ -I config/i370 -I ../include
# this is for DOS/VSE
#COPTS=-DTARGET_VSE -Os -S -fno-common -ansi -nostdinc -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -DI370 -D__NOBIVA__ -I config/i370 -I ../include
# This is for PDOS-generic via binutils
COPTS=-DTARGET_PDOSGB -Os -S -fno-common -ansi -nostdinc -DHAVE_CONFIG_H -DIN_GCC -DPUREISO -I ../../pdos/pdpclib -I . -DI370 -D__NOBIVA__ -I config/i370 -I ../include

all: clean gcc-new.exe

gcc-new.exe: \
    alias.obj \
    attribs.obj \
    bb-reorder.obj \
    bitmap.obj \
    builtins.obj \
    c-aux-info.obj \
    c-common.obj \
    c-convert.obj \
    c-decl.obj \
    c-errors.obj \
    c-format.obj \
    c-lang.obj \
    c-lex.obj \
    c-objc-common.obj \
    c-parse.obj \
    c-pragma.obj \
    c-semantics.obj \
    c-typeck.obj \
    caller-save.obj \
    calls.obj \
    cfg.obj \
    cfganal.obj \
    cfgbuild.obj \
    cfgcleanup.obj \
    cfglayout.obj \
    cfgloop.obj \
    cfgrtl.obj \
    combine.obj \
    conflict.obj \
    convert.obj \
    cppdefault.obj \
    cpperror.obj \
    cppexp.obj \
    cppfiles.obj \
    cpphash.obj \
    cppinit.obj \
    cpplex.obj \
    cpplib.obj \
    cppmacro.obj \
    cppmain.obj \
    cppspec.obj \
    cse.obj \
    cselib.obj \
    debug.obj \
    dependence.obj \
    df.obj \
    diagnostic.obj \
    dominance.obj \
    dwarf2asm.obj \
    dwarf2out.obj \
    emit-rtl.obj \
    except.obj \
    explow.obj \
    expmed.obj \
    expr.obj \
    final.obj \
    flow.obj \
    fold-const.obj \
    function.obj \
    gcc.obj \
    gccspec.obj \
    gcse.obj \
    genrtl.obj \
    ggc-common.obj \
    ggc-page.obj \
    global.obj \
    graph.obj \
    hash.obj \
    haifa-sched.obj \
    hashtable.obj \
    hooks.obj \
    ifcvt.obj \
    insn-attrtab.obj \
    insn-emit.obj \
    insn-extract.obj \
    insn-opinit.obj \
    insn-output.obj \
    insn-peep.obj \
    insn-recog.obj \
    integrate.obj \
    jump.obj \
    langhooks.obj \
    lcm.obj \
    line-map.obj \
    lists.obj \
    local-alloc.obj \
    loop.obj \
    mkdeps.obj \
    optabs.obj \
    params.obj \
    predict.obj \
    prefix.obj \
    print-rtl.obj \
    print-tree.obj \
    profile.obj \
    real.obj \
    recog.obj \
    regclass.obj \
    regmove.obj \
    regrename.obj \
    reload.obj \
    reload1.obj \
    resource.obj \
    rtl-error.obj \
    rtl.obj \
    rtlanal.obj \
    sbitmap.obj \
    sched-deps.obj \
    sched-rgn.obj \
    sched-vis.obj \
    sibcall.obj \
    simplify-rtx.obj \
    ssa-ccp.obj \
    ssa-dce.obj \
    ssa.obj \
    stmt.obj \
    stor-layout.obj \
    stringpool.obj \
    timevar.obj \
    toplev.obj \
    tree-dump.obj \
    tree-inline.obj \
    tree.obj \
    unroll.obj \
    varasm.obj \
    varray.obj \
    version.obj \
    ../libiberty/xmalloc.obj \
    ../libiberty/xstrerror.obj \
    ../libiberty/xstrdup.obj \
    ../libiberty/xexit.obj \
    ../libiberty/concat.obj \
    ../libiberty/hex.obj \
    ../libiberty/alloca.obj \
    ../libiberty/lbasename.obj \
    ../libiberty/obstack.obj \
    ../libiberty/strsignal.obj \
    ../libiberty/safe-ctype.obj \
    ../libiberty/splay-tree.obj \
    ../libiberty/fibheap.obj \
    ../libiberty/hashtab.obj \
    ../libiberty/asprintf.obj \
    ../libiberty/vasprintf.obj \
    ../libiberty/getpagesize.obj \
    ../libiberty/partition.obj \
    config/i370/i370.obj \
    config/i370/i370-c.obj \
    unixio.obj
  $(AR) s temp.lib
  $(LD) --oformat mvs -e __crt0 -o gcc-new.exe ../../pdos/pdpclib/pgastart.o temp.lib

.c.obj:
  $(CC) $(COPTS) -o $*.s $<
  $(AS) -o $@ $*.s
  rm -f $*.s
  $(AR) r temp.lib $*.obj
  rm -f $*.obj

clean:
  rm -f *.s
  rm -f *.obj
  rm -f temp.lib
  rm -f gcc-new.exe
