/*      PUREISO.C:      Operating specific I/O and Spawning functions
 *                      for an arbitrary operating system
 *                      for MicroEMACS 4.00
 *                      (C)Copyright 1995 by Daniel M. Lawrence
 *                      PUREISO version by Paul Edwards
 *
 * Most functions are dummied for now
 *
 */

#include <stdio.h>
#include <time.h>

#undef  PASCAL
#undef  NEAR
#undef  HIBYTE

#include        "estruct.h"
#include        "eproto.h"

#if     PUREISO

#include "elang.h"
#include "edef.h"

/*
 * Create a subjob with a copy of the command intrepreter in it. When the
 * command interpreter exits, mark the screen as garbage so that you do a full
 * repaint. Bound to "^X C". The message at the start in VMS puts out a newline.
 * Under some (unknown) condition, you don't get one free when DCL starts up.
 */
PASCAL NEAR spawncli(f, n)
{
        return(TRUE);
}


/*
 * Run a one-liner in a subjob. When the command returns, wait for a single
 * character to be typed, then mark the screen as garbage so a full repaint is
 * done. Bound to "C-X !".
 */
PASCAL NEAR spawn(f, n)
{
        return (TRUE);
}


/*
 * Run an external program with arguments. When it returns, wait for a single
 * character to be typed, then mark the screen as garbage so a full repaint is
 * done. Bound to "C-X $".
 */

PASCAL NEAR execprg(f, n)
{
        return (TRUE);
}

/*
 * Pipe a one line command into a window
 * Bound to ^X @
 * We use a unique temporary file name so that multiple instances of
 * MicroEMACS don't try to use the same file.
 */
PASCAL NEAR pipecmd(f, n)
{
        return(TRUE);
}


/*
 * filter a buffer through an external DOS program
 * Bound to ^X #
 * We use unique temporary file names so that multiple instances of
 * MicroEMACS don't try to use the same file.
 */
PASCAL NEAR filter(f, n)

{
        return(TRUE);
}



/*      SHELL: Bring up a shell. */

shell(void)
{
        return(TRUE);
}



execprog( char *cmd)
{
        return(TRUE);
}


/*      FILE Directory routines         */

/*      do a wild card directory search (for file name completion) */

char *PASCAL NEAR getffile(fspec)

char *fspec;    /* pattern to match */

{
        return(NULL);
}

char *PASCAL NEAR getnfile()

{
        return(NULL);
}

/* return a system dependant string with the current time */

char *PASCAL NEAR timeset()

{
        register char *sp;      /* temp string pointer */
        time_t tt;

        time(&tt);
        sp = ctime(&tt);
        sp[strlen(sp)-1] = 0;
        return(sp);
}

/** Open terminal device **/
int ttopen()
{
  setvbuf(stdin, NULL, _IONBF, 0);
  /* Success */
  return(0);
}

/** Close terminal device **/
int ttclose()
{
  setvbuf(stdin, NULL, _IOLBF, 0);
  /* Success */
  return(0);
}

/** Flush output buffer to display **/
int ttflush()
{
  fflush (stdout);
  return(0);
}

/** Put character onto display **/
int ttputc(ch)
{
    putc(ch, stdout);
}

/** Return cooked characters **/
int ttgetc()
{
  return (getc(stdin));
}

/** supposed to do a short wait, but we wait forever **/
int grabnowait()
{
  return (getc(stdin));
}

int typahead()
{
  return FALSE;
}

#endif
