/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "toplev.h"
#include "reload.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third argument to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl in a SEQUENCE if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in a SEQUENCE,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/





static int recog_1 PARAMS ((rtx, rtx, int *));
static int
recog_1 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  if (push_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L5;
    }
 L2947: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L306;
    }
 L2949: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L345;
    }
 L2955: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L1635;
    }
  goto ret0;

 L5: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (general_operand (x1, DImode))
    {
      operands[1] = x1;
      return 1;
    }
  x1 = XEXP (x0, 0);
  goto L2947;

 L306: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DImode)
    goto L2976;
 L283: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, DImode))
    {
      operands[1] = x1;
      goto L284;
    }
  x1 = XEXP (x0, 0);
  goto L2949;

 L2976: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      goto L307;
    case SIGN_EXTEND:
      goto L334;
    case PLUS:
      goto L543;
    case MINUS:
      goto L749;
    case AND:
      goto L1211;
    case IOR:
      goto L1267;
    case XOR:
      goto L1345;
    case NEG:
      goto L1401;
    case NOT:
      goto L1491;
    case ASHIFT:
      goto L1526;
    default:
     break;
   }
  goto L283;

 L307: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      return 53;
    }
 L311: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      return 54;
    }
 L315: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      return 55;
    }
  goto L283;

 L334: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      return 59;
    }
 L338: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      return 60;
    }
 L342: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      return 61;
    }
  goto L283;

 L543: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode)
    goto L2986;
 L593: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L594;
    }
  goto L283;

 L2986: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case LSHIFTRT:
      goto L544;
    case ASHIFT:
      goto L563;
    default:
     break;
   }
  goto L593;

 L544: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L545;
    }
  goto L593;

 L545: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT)
    goto L2988;
  goto L593;

 L2988: ATTRIBUTE_UNUSED_LABEL
  if ((int) XWINT (x3, 0) == XWINT (x3, 0))
    switch ((int) XWINT (x3, 0))
      {
      case 63:
        goto L546;
      case 32:
        goto L574;
      default:
        break;
      }
  goto L593;

 L546: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[1])
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 92;
    }
  x2 = XEXP (x1, 0);
  goto L593;

 L574: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      return 94;
    }
  x2 = XEXP (x1, 0);
  goto L593;

 L563: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == SIGN_EXTEND)
    goto L564;
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L580;
    }
  goto L593;

 L564: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, HImode))
    {
      operands[1] = x4;
      goto L565;
    }
  goto L593;

 L565: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    goto L566;
  goto L593;

 L566: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L567;
    }
  x2 = XEXP (x1, 0);
  goto L593;

 L567: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 93;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L593;

 L580: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    goto L581;
  goto L593;

 L581: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      return 95;
    }
  x2 = XEXP (x1, 0);
  goto L593;

 L594: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L595;
    }
  goto L283;

 L595: ATTRIBUTE_UNUSED_LABEL
  if (pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 96;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L749: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L750;
 L741: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L742;
    }
  goto L283;

 L750: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode
      && GET_CODE (x2) == ASHIFT)
    goto L751;
  x2 = XEXP (x1, 0);
  goto L741;

 L751: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L752;
    }
  x2 = XEXP (x1, 0);
  goto L741;

 L752: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    {
      return 118;
    }
  x2 = XEXP (x1, 0);
  goto L741;

 L742: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode
      && GET_CODE (x2) == ASHIFT)
    goto L743;
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L766;
    }
  goto L283;

 L743: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == SIGN_EXTEND)
    goto L744;
  goto L283;

 L744: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, HImode))
    {
      operands[2] = x4;
      goto L745;
    }
  goto L283;

 L745: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32
      && (!TARGET_5200)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 117;
    }
  goto L283;

 L766: ATTRIBUTE_UNUSED_LABEL
  if (pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 119;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1211: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1212;
    }
  goto L283;

 L1212: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L1213;
    }
  goto L283;

 L1213: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 175;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1267: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode
      && GET_CODE (x2) == ZERO_EXTEND)
    goto L1268;
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1275;
    }
  goto L283;

 L1268: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, VOIDmode))
    {
      operands[1] = x3;
      goto L1269;
    }
  goto L283;

 L1269: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L1270;
    }
  goto L283;

 L1270: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 184;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1275: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L1276;
    }
  goto L283;

 L1276: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 185;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1345: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1346;
    }
  goto L283;

 L1346: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L1347;
    }
  goto L283;

 L1347: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 196;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1401: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1402;
    }
  goto L283;

 L1402: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 205;
    }
 L1407: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 206;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1491: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1492;
    }
  goto L283;

 L1492: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 223;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L1526: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode)
    goto L2990;
 L1547: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1548;
    }
  goto L283;

 L2990: ATTRIBUTE_UNUSED_LABEL
  if (extend_operator (x2, DImode))
    {
      operands[2] = x2;
      goto L1527;
    }
 L2991: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == SIGN_EXTEND)
    goto L1542;
  goto L1547;

 L1527: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L1528;
    }
  goto L2991;

 L1528: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 32)
    {
      return 230;
    }
  x2 = XEXP (x1, 0);
  goto L2991;

 L1542: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L1543;
    }
  goto L1547;

 L1543: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 32
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 231;
    }
  x2 = XEXP (x1, 0);
  goto L1547;

 L1548: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L2992;
  goto L283;

 L2992: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 32)
    {
      return 232;
    }
 L2993: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, VOIDmode))
    {
      operands[2] = x2;
      goto L1554;
    }
  goto L283;

 L1554: ATTRIBUTE_UNUSED_LABEL
  if (((!TARGET_5200
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	|| INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	|| (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63)))))
    {
      return 233;
    }
  x1 = XEXP (x0, 1);
  goto L283;

 L284: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 47;
    }
 L288: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 48;
    }
  x1 = XEXP (x0, 0);
  goto L2949;

 L345: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DImode)
    goto L2994;
  x1 = XEXP (x0, 0);
  goto L2955;

 L2994: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      goto L346;
    case ASHIFTRT:
      goto L1623;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2955;

 L346: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == PLUS)
    goto L347;
  x1 = XEXP (x0, 0);
  goto L2955;

 L347: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L348;
    }
  x1 = XEXP (x0, 0);
  goto L2955;

 L348: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      return 62;
    }
  x1 = XEXP (x0, 0);
  goto L2955;

 L1623: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1624;
    }
  x1 = XEXP (x0, 0);
  goto L2955;

 L1624: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 32)
    {
      return 245;
    }
  x1 = XEXP (x0, 0);
  goto L2955;

 L1635: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DImode)
    goto L2996;
  goto ret0;

 L2996: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFTRT:
      goto L1636;
    case LSHIFTRT:
      goto L1689;
    default:
     break;
   }
  goto ret0;

 L1636: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1637;
    }
  goto ret0;

 L1637: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L2998;
  goto ret0;

 L2998: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 32
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 246;
    }
 L2999: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, VOIDmode))
    {
      operands[2] = x2;
      goto L1643;
    }
  goto ret0;

 L1643: ATTRIBUTE_UNUSED_LABEL
  if (((!TARGET_5200 
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	|| INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	|| INTVAL (operands[2]) == 31
	|| (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63)))))
    {
      return 247;
    }
  goto ret0;

 L1689: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[1] = x2;
      goto L1690;
    }
  goto ret0;

 L1690: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3000;
  goto ret0;

 L3000: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 32)
    {
      return 255;
    }
 L3001: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, VOIDmode))
    {
      operands[2] = x2;
      goto L1696;
    }
  goto ret0;

 L1696: ATTRIBUTE_UNUSED_LABEL
  if (((!TARGET_5200
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	 || INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	 || (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63)))))
    {
      return 256;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_2 PARAMS ((rtx, rtx, int *));
static int
recog_2 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 1);
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L599;
    case MINUS:
      goto L770;
    case MULT:
      goto L879;
    case IOR:
      goto L1330;
    case XOR:
      goto L1351;
    case NEG:
      goto L1411;
    case NOT:
      goto L1496;
    case SUBREG:
      goto L3036;
    case ZERO_EXTRACT:
      goto L1859;
    case SIGN_EXTRACT:
      goto L1873;
    default:
     break;
   }
  goto ret0;

 L599: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == LSHIFTRT)
    goto L600;
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L619;
    }
  goto ret0;

 L600: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L601;
    }
  goto ret0;

 L601: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 31)
    goto L602;
  goto ret0;

 L602: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[1]))
    {
      return 97;
    }
  goto ret0;

 L619: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == SIGN_EXTEND)
    goto L620;
  if (general_src_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L608;
    }
  goto ret0;

 L620: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_src_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L621;
    }
  goto ret0;

 L621: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 100;
    }
  goto ret0;

 L608: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_5200))
    {
      return 98;
    }
 L614: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 99;
    }
  goto ret0;

 L770: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L776;
    }
  goto ret0;

 L776: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == SIGN_EXTEND)
    goto L777;
  if (general_src_operand (x2, SImode))
    {
      operands[2] = x2;
      return 120;
    }
  goto ret0;

 L777: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_src_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L778;
    }
  goto ret0;

 L778: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 121;
    }
  goto ret0;

 L879: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode)
    goto L3037;
 L893: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L894;
    }
  goto ret0;

 L3037: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      goto L880;
    case ZERO_EXTEND:
      goto L906;
    default:
     break;
   }
  goto L893;

 L880: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L881;
    }
  goto L893;

 L881: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == SIGN_EXTEND)
    goto L882;
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L889;
    }
  x2 = XEXP (x1, 0);
  goto L893;

 L882: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_src_operand (x3, HImode))
    {
      operands[2] = x3;
      return 137;
    }
  x2 = XEXP (x1, 0);
  goto L893;

 L889: ATTRIBUTE_UNUSED_LABEL
  if ((INTVAL (operands[2]) >= -0x8000 && INTVAL (operands[2]) <= 0x7fff))
    {
      return 138;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L893;

 L906: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L907;
    }
  goto L893;

 L907: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == ZERO_EXTEND)
    goto L908;
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L915;
    }
  x2 = XEXP (x1, 0);
  goto L893;

 L908: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_src_operand (x3, HImode))
    {
      operands[2] = x3;
      return 141;
    }
  x2 = XEXP (x1, 0);
  goto L893;

 L915: ATTRIBUTE_UNUSED_LABEL
  if ((INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) <= 0xffff))
    {
      return 142;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L893;

 L894: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L895;
    }
 L900: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L901;
    }
  goto ret0;

 L895: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020))
    {
      return 139;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L900;

 L901: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 140;
    }
  goto ret0;

 L1330: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == ZERO_EXTEND)
    goto L1331;
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1281;
    }
  goto ret0;

 L1331: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L1332;
    }
 L1339: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, VOIDmode))
    {
      operands[1] = x3;
      goto L1340;
    }
  goto ret0;

 L1332: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == ASHIFT)
    goto L1333;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1339;

 L1333: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1334;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1339;

 L1334: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 16)
    {
      return 194;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1339;

 L1340: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1341;
    }
  goto ret0;

 L1341: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 195;
    }
  goto ret0;

 L1281: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1282;
    }
  goto ret0;

 L1282: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_5200))
    {
      return 186;
    }
 L1288: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 187;
    }
  goto ret0;

 L1351: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1352;
    }
  goto ret0;

 L1352: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1353;
    }
  goto ret0;

 L1353: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 197;
    }
 L1359: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 198;
    }
  goto ret0;

 L1411: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1412;
    }
  goto ret0;

 L1412: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 207;
    }
 L1417: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 208;
    }
  goto ret0;

 L1496: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1497;
    }
  goto ret0;

 L1497: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 224;
    }
 L1502: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 225;
    }
  goto ret0;

 L3036: ATTRIBUTE_UNUSED_LABEL
  if (XINT (x1, 1) == 4)
    goto L1617;
  goto ret0;

 L1617: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode)
    goto L3039;
  goto ret0;

 L3039: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case ASHIFTRT:
      goto L1618;
    case LSHIFTRT:
      goto L1684;
    default:
     break;
   }
  goto ret0;

 L1618: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L1619;
    }
  goto ret0;

 L1619: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    {
      return 244;
    }
  goto ret0;

 L1684: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L1685;
    }
  goto ret0;

 L1685: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    {
      return 254;
    }
  goto ret0;

 L1859: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L3041;
    case SImode:
      goto L3042;
    default:
      break;
    }
  goto ret0;

 L3041: ATTRIBUTE_UNUSED_LABEL
  if (memory_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1860;
    }
 L3043: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1895;
    }
  goto ret0;

 L1860: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 32)
    goto L1861;
  x2 = XEXP (x1, 0);
  goto L3043;

 L1861: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1862;
    }
  x2 = XEXP (x1, 0);
  goto L3043;

 L1862: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[1], 0))))
    {
      return 281;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L3043;

 L1895: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1896;
    }
  goto ret0;

 L1896: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1897;
    }
  goto ret0;

 L1897: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 286;
    }
  goto ret0;

 L3042: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1867;
    }
  goto ret0;

 L1867: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1868;
    }
 L1940: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1941;
    }
  goto ret0;

 L1868: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1869;
    }
  x2 = XEXP (x1, 1);
  goto L1940;

 L1869: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16)
   && INTVAL (operands[3]) % INTVAL (operands[2]) == 0
   && (GET_CODE (operands[1]) == REG
       || ! mode_dependent_address_p (XEXP (operands[1], 0)))))
    {
      return 282;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L1940;

 L1941: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1942;
    }
  goto ret0;

 L1942: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 292;
    }
  goto ret0;

 L1873: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L3044;
    case SImode:
      goto L3045;
    default:
      break;
    }
  goto ret0;

 L3044: ATTRIBUTE_UNUSED_LABEL
  if (memory_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1874;
    }
 L3046: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1888;
    }
  goto ret0;

 L1874: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 32)
    goto L1875;
  x2 = XEXP (x1, 0);
  goto L3046;

 L1875: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1876;
    }
  x2 = XEXP (x1, 0);
  goto L3046;

 L1876: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[1], 0))))
    {
      return 283;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L3046;

 L1888: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1889;
    }
  goto ret0;

 L1889: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1890;
    }
  goto ret0;

 L1890: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 285;
    }
  goto ret0;

 L3045: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1881;
    }
  goto ret0;

 L1881: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1882;
    }
 L1933: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1934;
    }
  goto ret0;

 L1882: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1883;
    }
  x2 = XEXP (x1, 1);
  goto L1933;

 L1883: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16)
   && INTVAL (operands[3]) % INTVAL (operands[2]) == 0
   && (GET_CODE (operands[1]) == REG
       || ! mode_dependent_address_p (XEXP (operands[1], 0)))))
    {
      return 284;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L1933;

 L1934: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1935;
    }
  goto ret0;

 L1935: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 291;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_3 PARAMS ((rtx, rtx, int *));
static int
recog_3 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  switch (GET_CODE (x1))
    {
    case MEM:
      goto L3002;
    case ZERO_EXTRACT:
      goto L1827;
    default:
     break;
   }
 L2941: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L318;
    }
 L2948: ATTRIBUTE_UNUSED_LABEL
  if (push_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L291;
    }
 L2950: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L598;
    }
 L2951: ATTRIBUTE_UNUSED_LABEL
  if (not_sp_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L1216;
    }
 L2952: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L1557;
    }
  goto ret0;

 L3002: ATTRIBUTE_UNUSED_LABEL
  if (push_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L200;
    }
  goto L2941;

 L200: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (const_int_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L201;
    }
  x1 = XEXP (x0, 0);
  goto L2941;

 L201: ATTRIBUTE_UNUSED_LABEL
  if ((INTVAL (operands[1]) >= -0x8000 && INTVAL (operands[1]) < 0x8000))
    {
      return 27;
    }
  x1 = XEXP (x0, 0);
  goto L2941;

 L1827: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L3003;
    case SImode:
      goto L3004;
    default:
      break;
    }
  goto ret0;

 L3003: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L1828;
    }
  goto ret0;

 L1828: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3005;
 L1901: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1902;
    }
  goto ret0;

 L3005: ATTRIBUTE_UNUSED_LABEL
  if ((int) XWINT (x2, 0) == XWINT (x2, 0))
    switch ((int) XWINT (x2, 0))
      {
      case 1:
        goto L1829;
      case 32:
        goto L1846;
      default:
        break;
      }
  goto L1901;

 L1829: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == MINUS)
    goto L1830;
  x2 = XEXP (x1, 1);
  goto L1901;

 L1830: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 7)
    goto L1839;
  x2 = XEXP (x1, 1);
  goto L1901;

 L1839: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (extend_operator (x3, SImode))
    {
      operands[2] = x3;
      goto L1840;
    }
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L1832;
    }
  x2 = XEXP (x1, 1);
  goto L1901;

 L1840: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, VOIDmode))
    {
      operands[1] = x4;
      goto L1841;
    }
  x2 = XEXP (x1, 1);
  goto L1901;

 L1841: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == 0)
    {
      return 278;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1901;

 L1832: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == 0)
    {
      return 277;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1901;

 L1846: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1847;
    }
  x2 = XEXP (x1, 1);
  goto L1901;

 L1847: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (general_src_operand (x1, SImode))
    {
      operands[2] = x1;
      goto L1848;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1901;

 L1848: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[1]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[0], 0))))
    {
      return 279;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1901;

 L1902: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1903;
    }
  goto ret0;

 L1903: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L3007;
 L1915: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == CONST_INT)
    goto L3009;
  goto ret0;

 L3007: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == XOR)
    goto L1904;
  if (register_operand (x1, SImode))
    {
      operands[3] = x1;
      goto L1928;
    }
  goto L1915;

 L1904: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == ZERO_EXTRACT)
    goto L1905;
  goto L1915;

 L1905: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[0]))
    goto L1906;
  goto L1915;

 L1906: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[1]))
    goto L1907;
  goto L1915;

 L1907: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[2]))
    goto L1908;
  goto L1915;

 L1908: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, VOIDmode))
    {
      operands[3] = x2;
      goto L1909;
    }
  goto L1915;

 L1909: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[3]) == -1
       || (GET_CODE (operands[1]) == CONST_INT
           && (~ INTVAL (operands[3]) & ((1 << INTVAL (operands[1]))- 1)) == 0))))
    {
      return 287;
    }
  x1 = XEXP (x0, 1);
  goto L1915;

 L1928: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 290;
    }
  x1 = XEXP (x0, 1);
  goto L1915;

 L3009: ATTRIBUTE_UNUSED_LABEL
  if ((int) XWINT (x1, 0) == XWINT (x1, 0))
    switch ((int) XWINT (x1, 0))
      {
      case 0:
        goto L3011;
      case -1:
        goto L3012;
      default:
        break;
      }
  goto ret0;

 L3011: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 288;
    }
  goto ret0;

 L3012: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 289;
    }
  goto ret0;

 L3004: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L1852;
    }
  goto ret0;

 L1852: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1853;
    }
 L1946: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1947;
    }
  goto ret0;

 L1853: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1854;
    }
  x2 = XEXP (x1, 1);
  goto L1946;

 L1854: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      operands[3] = x1;
      goto L1855;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1946;

 L1855: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[1]) == 8 || INTVAL (operands[1]) == 16)
   && INTVAL (operands[2]) % INTVAL (operands[1]) == 0
   && (GET_CODE (operands[0]) == REG
       || ! mode_dependent_address_p (XEXP (operands[0], 0)))))
    {
      return 280;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 1);
  goto L1946;

 L1947: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1960;
    }
  goto ret0;

 L1960: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      operands[3] = x1;
      goto L1961;
    }
  if (GET_CODE (x1) == CONST_INT)
    goto L3013;
  goto ret0;

 L1961: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 295;
    }
  goto ret0;

 L3013: ATTRIBUTE_UNUSED_LABEL
  if ((int) XWINT (x1, 0) == XWINT (x1, 0))
    switch ((int) XWINT (x1, 0))
      {
      case 0:
        goto L3015;
      case -1:
        goto L3016;
      default:
        break;
      }
  goto ret0;

 L3015: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 293;
    }
  goto ret0;

 L3016: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 294;
    }
  goto ret0;

 L318: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L3017;
 L204: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == 0
      && (((TARGET_68020 || TARGET_5200)
    || !(GET_CODE (operands[0]) == MEM && MEM_VOLATILE_P (operands[0])))))
    {
      return 28;
    }
 L207: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L208;
    }
 L211: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L212;
    }
 L215: ATTRIBUTE_UNUSED_LABEL
  if (pcrel_address (x1, SImode))
    {
      operands[1] = x1;
      goto L216;
    }
  x1 = XEXP (x0, 0);
  goto L2948;

 L3017: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      goto L319;
    case SIGN_EXTEND:
      goto L352;
    case FIX:
      goto L441;
    default:
     break;
   }
  goto L204;

 L319: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      goto L3020;
    case QImode:
      goto L3021;
    default:
      break;
    }
  goto L204;

 L3020: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L320;
    }
  goto L204;

 L320: ATTRIBUTE_UNUSED_LABEL
  if ((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) != MEM))
    {
      return 56;
    }
  x1 = XEXP (x0, 1);
  goto L204;

 L3021: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L330;
    }
  goto L204;

 L330: ATTRIBUTE_UNUSED_LABEL
  if ((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) != MEM))
    {
      return 58;
    }
  x1 = XEXP (x0, 1);
  goto L204;

 L352: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      goto L3022;
    case QImode:
      goto L3023;
    default:
      break;
    }
  goto L204;

 L3022: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_src_operand (x2, HImode))
    {
      operands[1] = x2;
      return 63;
    }
  goto L204;

 L3023: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L361;
    }
  goto L204;

 L361: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 || TARGET_5200))
    {
      return 65;
    }
  x1 = XEXP (x0, 1);
  goto L204;

 L441: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DFmode:
      goto L3024;
    case SFmode:
      goto L3025;
    default:
      break;
    }
 L501: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L502;
    }
 L516: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L517;
    }
  goto L204;

 L3024: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FIX)
    goto L442;
  goto L516;

 L442: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L443;
    }
 L528: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L529;
    }
  goto L516;

 L443: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 2;
      return 79;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L528;

 L529: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 91;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L516;

 L3025: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FIX)
    goto L522;
  goto L501;

 L522: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L523;
    }
  goto L501;

 L523: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 90;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L501;

 L502: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 86;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L516;

 L517: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 89;
    }
  x1 = XEXP (x0, 1);
  goto L204;

 L208: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 29;
    }
  x1 = XEXP (x0, 1);
  goto L211;

 L212: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 30;
    }
  x1 = XEXP (x0, 1);
  goto L215;

 L216: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_PCREL))
    {
      return 31;
    }
  x1 = XEXP (x0, 0);
  goto L2948;

 L291: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (address_operand (x1, SImode))
    {
      operands[1] = x1;
      return 49;
    }
  x1 = XEXP (x0, 0);
  goto L2950;

 L598: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L3026;
  x1 = XEXP (x0, 0);
  goto L2951;

 L3026: ATTRIBUTE_UNUSED_LABEL
  tem = recog_2 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  x1 = XEXP (x0, 0);
  goto L2951;

 L1216: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == AND)
    goto L1217;
  x1 = XEXP (x0, 0);
  goto L2952;

 L1217: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1218;
    }
  x1 = XEXP (x0, 0);
  goto L2952;

 L1218: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1219;
    }
  x1 = XEXP (x0, 0);
  goto L2952;

 L1219: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 176;
    }
 L1225: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 177;
    }
  x1 = XEXP (x0, 0);
  goto L2952;

 L1557: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L3047;
  goto ret0;

 L3047: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      goto L1558;
    case ASHIFTRT:
      goto L1600;
    case LSHIFTRT:
      goto L1700;
    case ROTATE:
      goto L1747;
    case ROTATERT:
      goto L1779;
    default:
     break;
   }
  goto ret0;

 L1558: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1559;
    }
  goto ret0;

 L1559: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3052;
 L1570: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      return 236;
    }
  goto ret0;

 L3052: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 16
      && (!TARGET_68060))
    {
      return 234;
    }
 L3053: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1565;
    }
  goto L1570;

 L1565: ATTRIBUTE_UNUSED_LABEL
  if (((! TARGET_68020 && !TARGET_5200
    && INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 24)))
    {
      return 235;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L1570;

 L1600: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1601;
    }
  goto ret0;

 L1601: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3054;
 L1653: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      return 249;
    }
  goto ret0;

 L3054: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 16
      && (!TARGET_68060))
    {
      return 241;
    }
 L3055: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1607;
    }
 L3056: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 31)
    {
      return 248;
    }
  goto L1653;

 L1607: ATTRIBUTE_UNUSED_LABEL
  if (((! TARGET_68020 && !TARGET_5200
    && INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 24)))
    {
      return 242;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L3056;

 L1700: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1701;
    }
  goto ret0;

 L1701: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3057;
 L1717: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      return 260;
    }
  goto ret0;

 L3057: ATTRIBUTE_UNUSED_LABEL
  if ((int) XWINT (x2, 0) == XWINT (x2, 0))
    switch ((int) XWINT (x2, 0))
      {
      case 31:
        goto L3060;
      case 16:
        goto L3061;
      default:
        break;
      }
 L3059: ATTRIBUTE_UNUSED_LABEL
  if (const_int_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1712;
    }
  goto L1717;

 L3060: ATTRIBUTE_UNUSED_LABEL
  return 257;

 L3061: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_68060))
    {
      return 258;
    }
  goto L3059;

 L1712: ATTRIBUTE_UNUSED_LABEL
  if (((! TARGET_68020 && !TARGET_5200
    && INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 24)))
    {
      return 259;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L1717;

 L1747: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1748;
    }
  goto ret0;

 L1748: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1749;
    }
  goto ret0;

 L1749: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 265;
    }
  goto ret0;

 L1779: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1780;
    }
  goto ret0;

 L1780: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1781;
    }
  goto ret0;

 L1781: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 270;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_4 PARAMS ((rtx, rtx, int *));
static int
recog_4 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  if (nonimmediate_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L294;
    }
 L2954: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L1586;
    }
 L2956: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L1810;
    }
  goto ret0;

 L294: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode)
    goto L3079;
 L237: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x1, QImode))
    {
      operands[1] = x1;
      goto L238;
    }
  if (valid_dbcc_comparison_p (x1, VOIDmode))
    {
      operands[1] = x1;
      goto L1979;
    }
  x1 = XEXP (x0, 0);
  goto L2954;

 L3079: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case TRUNCATE:
      goto L295;
    case FIX:
      goto L475;
    case PLUS:
      goto L644;
    case MINUS:
      goto L795;
    case AND:
      goto L1248;
    case IOR:
      goto L1311;
    case XOR:
      goto L1382;
    case NEG:
      goto L1431;
    case NOT:
      goto L1516;
    default:
     break;
   }
  goto L237;

 L295: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_src_operand (x2, SImode))
    {
      operands[1] = x2;
      return 50;
    }
 L299: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      return 51;
    }
  goto L237;

 L475: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FIX)
    goto L476;
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L492;
    }
 L506: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L507;
    }
  goto L237;

 L476: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L477;
    }
  goto L237;

 L477: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 2;
      return 81;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L492: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 84;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L506;

 L507: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 87;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L644: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L645;
    }
  goto L237;

 L645: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L646;
    }
  goto L237;

 L646: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 104;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L795: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L796;
    }
  goto L237;

 L796: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L797;
    }
  goto L237;

 L797: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 124;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L1248: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1249;
    }
  goto L237;

 L1249: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1250;
    }
  goto L237;

 L1250: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 181;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L1311: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1312;
    }
  goto L237;

 L1312: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1313;
    }
  goto L237;

 L1313: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 191;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L1382: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1383;
    }
  goto L237;

 L1383: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1384;
    }
  goto L237;

 L1384: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 202;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L1431: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1432;
    }
  goto L237;

 L1432: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 211;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L1516: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1517;
    }
  goto L237;

 L1517: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 228;
    }
  x1 = XEXP (x0, 1);
  goto L237;

 L238: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 36;
    }
 L242: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 37;
    }
  x1 = XEXP (x0, 0);
  goto L2954;

 L1979: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DImode))
    {
      operands[2] = x2;
      goto L1980;
    }
  x1 = XEXP (x0, 0);
  goto L2954;

 L1980: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT)
    goto L3088;
 L1990: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DImode))
    {
      operands[3] = x2;
      goto L1991;
    }
  x1 = XEXP (x0, 0);
  goto L2954;

 L3088: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x2, 0) == 0)
    goto L3090;
  goto L1990;

 L3090: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_5200))
    {
      return 298;
    }
 L3091: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 299;
    }
  goto L1990;

 L1991: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_5200))
    {
      return 300;
    }
 L1997: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 301;
    }
  x1 = XEXP (x0, 0);
  goto L2954;

 L1586: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode)
    goto L3092;
  x1 = XEXP (x0, 0);
  goto L2956;

 L3092: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      goto L1587;
    case ASHIFTRT:
      goto L1670;
    case LSHIFTRT:
      goto L1734;
    case ROTATE:
      goto L1766;
    case ROTATERT:
      goto L1798;
    case EQ:
      goto L2001;
    case NE:
      goto L2006;
    case GT:
      goto L2011;
    case GTU:
      goto L2016;
    case LT:
      goto L2021;
    case LTU:
      goto L2026;
    case GE:
      goto L2031;
    case GEU:
      goto L2036;
    case LE:
      goto L2041;
    case LEU:
      goto L2046;
    case ORDERED:
      goto L2051;
    case UNORDERED:
      goto L2056;
    case UNEQ:
      goto L2061;
    case UNGE:
      goto L2066;
    case UNGT:
      goto L2071;
    case UNLE:
      goto L2076;
    case UNLT:
      goto L2081;
    case LTGT:
      goto L2086;
    case NOT:
      goto L2091;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1587: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1588;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1588: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1589;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1589: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 239;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1670: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1671;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1671: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1672;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1672: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 252;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1734: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1735;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1735: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1736;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1736: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 263;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1766: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1767;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1767: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1768;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1768: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 268;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1798: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1799;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1799: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[2] = x2;
      goto L1800;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1800: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 273;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2001: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2002;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2002: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 302;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2006: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2007;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2007: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 303;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2011: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2012;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2012: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 304;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2016: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2017;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2017: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 305;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2021: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2022;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2022: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 306;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2026: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2027;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2027: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 307;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2031: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2032;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2032: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 308;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2036: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2037;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2037: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 309;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2041: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2042;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2042: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 310;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2046: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2047;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2047: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    {
      return 311;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2051: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2052;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2052: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 312;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2056: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2057;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2057: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 313;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2061: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2062;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2062: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 314;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2066: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2067;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2067: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 315;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2071: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2072;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2072: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 316;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2076: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2077;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2077: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 317;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2081: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2082;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2082: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 318;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2086: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2087;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2087: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 319;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2091: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode)
    goto L3116;
  x1 = XEXP (x0, 0);
  goto L2956;

 L3116: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case UNLE:
      goto L2092;
    case UNLT:
      goto L2098;
    case UNGE:
      goto L2104;
    case UNGT:
      goto L2110;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2092: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2093;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2093: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 320;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2098: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2099;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2099: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 321;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2104: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2105;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2105: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 322;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L2110: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2111;
  x1 = XEXP (x0, 0);
  goto L2956;

 L2111: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0
      && (TARGET_68881 && !TARGET_68060))
    {
      return 323;
    }
  x1 = XEXP (x0, 0);
  goto L2956;

 L1810: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode
      && GET_CODE (x1) == IOR)
    goto L1811;
  goto ret0;

 L1811: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode
      && GET_CODE (x2) == SUBREG
      && XINT (x2, 1) == 3)
    goto L1812;
  goto ret0;

 L1812: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == ASHIFT)
    goto L1813;
  goto ret0;

 L1813: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 1)
    goto L1822;
  goto ret0;

 L1822: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (extend_operator (x4, SImode))
    {
      operands[2] = x4;
      goto L1823;
    }
  if (general_operand (x4, SImode))
    {
      operands[1] = x4;
      goto L1815;
    }
  goto ret0;

 L1823: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (general_operand (x5, VOIDmode))
    {
      operands[1] = x5;
      goto L1824;
    }
  goto ret0;

 L1824: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0]))
    {
      return 276;
    }
  goto ret0;

 L1815: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0]))
    {
      return 275;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_5 PARAMS ((rtx, rtx, int *));
static int
recog_5 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      goto L3142;
    case QImode:
      goto L3143;
    default:
      break;
    }
  goto ret0;

 L3142: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[0] = x2;
      goto L631;
    }
 L3144: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, HImode))
    {
      operands[0] = x2;
      goto L1580;
    }
  goto ret0;

 L631: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode)
    goto L3146;
 L228: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L229;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 0);
  goto L3144;

 L3146: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L632;
    case MINUS:
      goto L789;
    case AND:
      goto L1236;
    case IOR:
      goto L1299;
    case XOR:
      goto L1370;
    case NEG:
      goto L1427;
    case NOT:
      goto L1512;
    default:
     break;
   }
  goto L228;

 L632: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L633;
 L639: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L640;
    }
  goto L228;

 L633: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L634;
    }
  x2 = XEXP (x1, 0);
  goto L639;

 L634: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 102;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L639;

 L640: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 103;
    }
  goto L228;

 L789: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L790;
  goto L228;

 L790: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L791;
    }
  goto L228;

 L791: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 123;
    }
  x1 = XEXP (x0, 1);
  goto L228;

 L1236: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1237;
 L1243: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1244;
    }
  goto L228;

 L1237: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1238;
    }
  x2 = XEXP (x1, 0);
  goto L1243;

 L1238: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 179;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1243;

 L1244: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 180;
    }
  goto L228;

 L1299: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1300;
 L1306: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1307;
    }
  goto L228;

 L1300: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1301;
    }
  x2 = XEXP (x1, 0);
  goto L1306;

 L1301: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 189;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1306;

 L1307: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 190;
    }
  goto L228;

 L1370: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1371;
 L1377: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1378;
    }
  goto L228;

 L1371: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1372;
    }
  x2 = XEXP (x1, 0);
  goto L1377;

 L1372: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 200;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1377;

 L1378: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 201;
    }
  goto L228;

 L1427: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 210;
    }
  goto L228;

 L1512: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 227;
    }
  goto L228;

 L229: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 34;
    }
 L234: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 35;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 0);
  goto L3144;

 L1580: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode)
    goto L3153;
  goto ret0;

 L3153: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      goto L1581;
    case ASHIFTRT:
      goto L1664;
    case LSHIFTRT:
      goto L1728;
    case ROTATE:
      goto L1760;
    case ROTATERT:
      goto L1792;
    default:
     break;
   }
  goto ret0;

 L1581: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1582;
  goto ret0;

 L1582: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1583;
    }
  goto ret0;

 L1583: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 238;
    }
  goto ret0;

 L1664: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1665;
  goto ret0;

 L1665: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1666;
    }
  goto ret0;

 L1666: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 251;
    }
  goto ret0;

 L1728: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1729;
  goto ret0;

 L1729: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1730;
    }
  goto ret0;

 L1730: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 262;
    }
  goto ret0;

 L1760: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1761;
  goto ret0;

 L1761: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1762;
    }
  goto ret0;

 L1762: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 267;
    }
  goto ret0;

 L1792: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1793;
  goto ret0;

 L1793: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1794;
    }
  goto ret0;

 L1794: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 272;
    }
  goto ret0;

 L3143: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L650;
    }
 L3145: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L1593;
    }
  goto ret0;

 L650: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode)
    goto L3158;
 L246: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x1, QImode))
    {
      operands[1] = x1;
      goto L247;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 0);
  goto L3145;

 L3158: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L651;
    case MINUS:
      goto L802;
    case AND:
      goto L1255;
    case IOR:
      goto L1318;
    case XOR:
      goto L1389;
    case NEG:
      goto L1437;
    case NOT:
      goto L1522;
    default:
     break;
   }
  goto L246;

 L651: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L652;
 L658: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L659;
    }
  goto L246;

 L652: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L653;
    }
  x2 = XEXP (x1, 0);
  goto L658;

 L653: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 105;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L658;

 L659: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 106;
    }
  goto L246;

 L802: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L803;
  goto L246;

 L803: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L804;
    }
  goto L246;

 L804: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 125;
    }
  x1 = XEXP (x0, 1);
  goto L246;

 L1255: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1256;
 L1262: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1263;
    }
  goto L246;

 L1256: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1257;
    }
  x2 = XEXP (x1, 0);
  goto L1262;

 L1257: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 182;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1262;

 L1263: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 183;
    }
  goto L246;

 L1318: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1319;
 L1325: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1326;
    }
  goto L246;

 L1319: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1320;
    }
  x2 = XEXP (x1, 0);
  goto L1325;

 L1320: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 192;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1325;

 L1326: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 193;
    }
  goto L246;

 L1389: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1390;
 L1396: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1397;
    }
  goto L246;

 L1390: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1391;
    }
  x2 = XEXP (x1, 0);
  goto L1396;

 L1391: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 203;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L1396;

 L1397: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 204;
    }
  goto L246;

 L1437: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 212;
    }
  goto L246;

 L1522: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0])
      && (!TARGET_5200))
    {
      return 229;
    }
  goto L246;

 L247: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 38;
    }
 L252: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 39;
    }
  x1 = XEXP (x0, 0);
  x2 = XEXP (x1, 0);
  goto L3145;

 L1593: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode)
    goto L3165;
  goto ret0;

 L3165: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      goto L1594;
    case ASHIFTRT:
      goto L1677;
    case LSHIFTRT:
      goto L1741;
    case ROTATE:
      goto L1773;
    case ROTATERT:
      goto L1805;
    default:
     break;
   }
  goto ret0;

 L1594: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1595;
  goto ret0;

 L1595: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1596;
    }
  goto ret0;

 L1596: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 240;
    }
  goto ret0;

 L1677: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1678;
  goto ret0;

 L1678: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1679;
    }
  goto ret0;

 L1679: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 253;
    }
  goto ret0;

 L1741: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1742;
  goto ret0;

 L1742: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1743;
    }
  goto ret0;

 L1743: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 264;
    }
  goto ret0;

 L1773: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1774;
  goto ret0;

 L1774: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1775;
    }
  goto ret0;

 L1775: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 269;
    }
  goto ret0;

 L1805: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L1806;
  goto ret0;

 L1806: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L1807;
    }
  goto ret0;

 L1807: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 274;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_6 PARAMS ((rtx, rtx, int *));
static int
recog_6 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case EQ:
      goto L2176;
    case NE:
      goto L2185;
    case GE:
      goto L2230;
    case LT:
      goto L2212;
    case GT:
      goto L2194;
    case GTU:
      goto L2203;
    case LTU:
      goto L2221;
    case GEU:
      goto L2239;
    case LE:
      goto L2248;
    case LEU:
      goto L2257;
    case ORDERED:
      goto L2266;
    case UNORDERED:
      goto L2275;
    case UNEQ:
      goto L2284;
    case UNGE:
      goto L2293;
    case UNGT:
      goto L2302;
    case UNLE:
      goto L2311;
    case UNLT:
      goto L2320;
    case LTGT:
      goto L2329;
    default:
     break;
   }
  goto ret0;

 L2176: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2177;
  if (general_operand (x3, DImode))
    {
      operands[0] = x3;
      goto L2129;
    }
  goto ret0;

 L2177: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2178;
  goto ret0;

 L2178: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2179;
    case PC:
      goto L2341;
    default:
     break;
   }
  goto ret0;

 L2179: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2180;

 L2180: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 328;
    }
  goto ret0;

 L2341: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2342;
  goto ret0;

 L2342: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 346;

 L2129: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2130;
  goto ret0;

 L2130: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2131;
  goto ret0;

 L2131: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  goto L2132;

 L2132: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 324;
    }
  goto ret0;

 L2185: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2186;
  if (general_operand (x3, DImode))
    {
      operands[0] = x3;
      goto L2150;
    }
  goto ret0;

 L2186: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2187;
  goto ret0;

 L2187: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2188;
    case PC:
      goto L2350;
    default:
     break;
   }
  goto ret0;

 L2188: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2189;

 L2189: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 329;
    }
  goto ret0;

 L2350: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2351;
  goto ret0;

 L2351: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 347;

 L2150: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2151;
  goto ret0;

 L2151: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2152;
  goto ret0;

 L2152: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  goto L2153;

 L2153: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 325;
    }
  goto ret0;

 L2230: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2231;
  if (general_operand (x3, DImode))
    {
      operands[0] = x3;
      goto L2159;
    }
  goto ret0;

 L2231: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2232;
  goto ret0;

 L2232: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2233;
    case PC:
      goto L2395;
    default:
     break;
   }
  goto ret0;

 L2233: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2234;

 L2234: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 334;
    }
  goto ret0;

 L2395: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2396;
  goto ret0;

 L2396: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 352;

 L2159: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2160;
  goto ret0;

 L2160: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2161;
  goto ret0;

 L2161: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  goto L2162;

 L2162: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 326;
    }
  goto ret0;

 L2212: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2213;
  if (general_operand (x3, DImode))
    {
      operands[0] = x3;
      goto L2168;
    }
  goto ret0;

 L2213: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2214;
  goto ret0;

 L2214: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2215;
    case PC:
      goto L2377;
    default:
     break;
   }
  goto ret0;

 L2215: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2216;

 L2216: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 332;
    }
  goto ret0;

 L2377: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2378;
  goto ret0;

 L2378: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 350;

 L2168: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2169;
  goto ret0;

 L2169: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2170;
  goto ret0;

 L2170: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  goto L2171;

 L2171: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 327;
    }
  goto ret0;

 L2194: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2195;
  goto ret0;

 L2195: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2196;
  goto ret0;

 L2196: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2197;
    case PC:
      goto L2359;
    default:
     break;
   }
  goto ret0;

 L2197: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2198;

 L2198: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 330;
    }
  goto ret0;

 L2359: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2360;
  goto ret0;

 L2360: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 348;

 L2203: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2204;
  goto ret0;

 L2204: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2205;
  goto ret0;

 L2205: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2206;
    case PC:
      goto L2368;
    default:
     break;
   }
  goto ret0;

 L2206: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2207;

 L2207: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 331;
    }
  goto ret0;

 L2368: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2369;
  goto ret0;

 L2369: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 349;

 L2221: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2222;
  goto ret0;

 L2222: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2223;
  goto ret0;

 L2223: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2224;
    case PC:
      goto L2386;
    default:
     break;
   }
  goto ret0;

 L2224: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2225;

 L2225: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 333;
    }
  goto ret0;

 L2386: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2387;
  goto ret0;

 L2387: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 351;

 L2239: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2240;
  goto ret0;

 L2240: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2241;
  goto ret0;

 L2241: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2242;
    case PC:
      goto L2404;
    default:
     break;
   }
  goto ret0;

 L2242: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2243;

 L2243: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 335;
    }
  goto ret0;

 L2404: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2405;
  goto ret0;

 L2405: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 353;

 L2248: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2249;
  goto ret0;

 L2249: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2250;
  goto ret0;

 L2250: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2251;
    case PC:
      goto L2413;
    default:
     break;
   }
  goto ret0;

 L2251: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2252;

 L2252: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 336;
    }
  goto ret0;

 L2413: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2414;
  goto ret0;

 L2414: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 354;

 L2257: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2258;
  goto ret0;

 L2258: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2259;
  goto ret0;

 L2259: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2260;
    case PC:
      goto L2422;
    default:
     break;
   }
  goto ret0;

 L2260: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2261;

 L2261: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 337;
    }
  goto ret0;

 L2422: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2423;
  goto ret0;

 L2423: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  return 355;

 L2266: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2267;
  goto ret0;

 L2267: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2268;
  goto ret0;

 L2268: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2269;
    case PC:
      goto L2431;
    default:
     break;
   }
  goto ret0;

 L2269: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2270;

 L2270: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 338;
    }
  goto ret0;

 L2431: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2432;
  goto ret0;

 L2432: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2433;

 L2433: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 356;
    }
  goto ret0;

 L2275: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2276;
  goto ret0;

 L2276: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2277;
  goto ret0;

 L2277: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2278;
    case PC:
      goto L2441;
    default:
     break;
   }
  goto ret0;

 L2278: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2279;

 L2279: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 339;
    }
  goto ret0;

 L2441: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2442;
  goto ret0;

 L2442: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2443;

 L2443: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 357;
    }
  goto ret0;

 L2284: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2285;
  goto ret0;

 L2285: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2286;
  goto ret0;

 L2286: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2287;
    case PC:
      goto L2451;
    default:
     break;
   }
  goto ret0;

 L2287: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2288;

 L2288: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 340;
    }
  goto ret0;

 L2451: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2452;
  goto ret0;

 L2452: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2453;

 L2453: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 358;
    }
  goto ret0;

 L2293: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2294;
  goto ret0;

 L2294: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2295;
  goto ret0;

 L2295: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2296;
    case PC:
      goto L2461;
    default:
     break;
   }
  goto ret0;

 L2296: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2297;

 L2297: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 341;
    }
  goto ret0;

 L2461: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2462;
  goto ret0;

 L2462: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2463;

 L2463: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 359;
    }
  goto ret0;

 L2302: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2303;
  goto ret0;

 L2303: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2304;
  goto ret0;

 L2304: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2305;
  goto ret0;

 L2305: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2306;

 L2306: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 342;
    }
  goto ret0;

 L2311: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2312;
  goto ret0;

 L2312: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2313;
  goto ret0;

 L2313: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2314;
    case PC:
      goto L2471;
    default:
     break;
   }
  goto ret0;

 L2314: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2315;

 L2315: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 343;
    }
  goto ret0;

 L2471: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2472;
  goto ret0;

 L2472: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2473;

 L2473: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 360;
    }
  goto ret0;

 L2320: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2321;
  goto ret0;

 L2321: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2322;
  goto ret0;

 L2322: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2323;
    case PC:
      goto L2481;
    default:
     break;
   }
  goto ret0;

 L2323: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2324;

 L2324: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 344;
    }
  goto ret0;

 L2481: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2482;
  goto ret0;

 L2482: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2483;

 L2483: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 361;
    }
  goto ret0;

 L2329: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0)
    goto L2330;
  goto ret0;

 L2330: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 0)
    goto L2331;
  goto ret0;

 L2331: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L2332;
    case PC:
      goto L2491;
    default:
     break;
   }
  goto ret0;

 L2332: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2333;

 L2333: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC
      && (TARGET_68881))
    {
      return 345;
    }
  goto ret0;

 L2491: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2492;
  goto ret0;

 L2492: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L2493;

 L2493: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 362;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_7 PARAMS ((rtx, rtx, int *));
static int
recog_7 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case DFmode:
      goto L2938;
    case DImode:
      goto L2939;
    case SImode:
      goto L2940;
    case HImode:
      goto L2942;
    case QImode:
      goto L2943;
    case SFmode:
      goto L2944;
    case XFmode:
      goto L2946;
    default:
      break;
    }
 L15: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case CC0:
      goto L16;
    case STRICT_LOW_PART:
      goto L227;
    case PC:
      goto L2126;
    default:
     break;
   }
 L2588: ATTRIBUTE_UNUSED_LABEL
  operands[0] = x1;
  goto L2589;
 L2608: ATTRIBUTE_UNUSED_LABEL
  switch (GET_MODE (x1))
    {
    case SImode:
      goto L2958;
    case DFmode:
      goto L2959;
    case SFmode:
      goto L2960;
    case XFmode:
      goto L2961;
    case QImode:
      goto L2964;
    case HImode:
      goto L2965;
    default:
      break;
    }
 L2605: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PC:
      goto L2606;
    case CC0:
      goto L2708;
    default:
     break;
   }
  goto ret0;

 L2938: ATTRIBUTE_UNUSED_LABEL
  if (push_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L2;
    }
 L2945: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L364;
    }
  goto L15;

 L2: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (general_operand (x1, DFmode))
    {
      operands[1] = x1;
      return 0;
    }
  x1 = XEXP (x0, 0);
  goto L2945;

 L364: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DFmode)
    goto L2966;
 L263: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, DFmode))
    {
      operands[1] = x1;
      goto L264;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L2966: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case FLOAT_EXTEND:
      goto L365;
    case FLOAT:
      goto L400;
    case FIX:
      goto L481;
    case PLUS:
      goto L669;
    case MINUS:
      goto L808;
    case MULT:
      goto L1041;
    case DIV:
      goto L1101;
    case NEG:
      goto L1451;
    case SQRT:
      goto L1466;
    case ABS:
      goto L1481;
    default:
     break;
   }
  goto L263;

 L365: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L366;
    }
  goto L263;

 L366: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 66;
    }
 L371: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 67;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L400: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L401;
    }
 L415: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L416;
    }
 L425: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L426;
    }
  goto L263;

 L401: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 73;
    }
 L406: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 74;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L415;

 L416: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 76;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L425;

 L426: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 78;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L481: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L482;
    }
  goto L263;

 L482: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && !TARGET_68040))
    {
      return 82;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L669: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FLOAT)
    goto L670;
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L664;
    }
  goto L263;

 L670: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L671;
    }
 L677: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L678;
    }
 L684: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L685;
    }
  goto L263;

 L671: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L672;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L677;

 L672: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 108;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L677;

 L678: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L679;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L684;

 L679: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 109;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L684;

 L685: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L686;
    }
  goto L263;

 L686: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 110;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L664: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[2] = x2;
      goto L665;
    }
  goto L263;

 L665: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 107;
    }
 L692: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 111;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L808: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L815;
    }
  goto L263;

 L815: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FLOAT)
    goto L816;
  if (general_operand (x2, DFmode))
    {
      operands[2] = x2;
      goto L810;
    }
  goto L263;

 L816: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L817;
    }
 L823: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L824;
    }
 L830: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L831;
    }
  goto L263;

 L817: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 127;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L823;

 L824: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 128;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L830;

 L831: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 129;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L810: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 126;
    }
 L837: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 130;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1041: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FLOAT)
    goto L1042;
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1036;
    }
  goto L263;

 L1042: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1043;
    }
 L1049: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1050;
    }
 L1056: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L1057;
    }
  goto L263;

 L1043: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1044;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1049;

 L1044: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 152;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1049;

 L1050: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1051;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1056;

 L1051: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 153;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1056;

 L1057: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1058;
    }
  goto L263;

 L1058: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 154;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1036: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[2] = x2;
      goto L1037;
    }
  goto L263;

 L1037: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 151;
    }
 L1064: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 155;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1101: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1108;
    }
  goto L263;

 L1108: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FLOAT)
    goto L1109;
  if (general_operand (x2, DFmode))
    {
      operands[2] = x2;
      goto L1103;
    }
  goto L263;

 L1109: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1110;
    }
 L1116: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1117;
    }
 L1123: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L1124;
    }
  goto L263;

 L1110: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 162;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1116;

 L1117: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 163;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1123;

 L1124: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 164;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1103: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 161;
    }
 L1130: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 165;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1451: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1452;
    }
  goto L263;

 L1452: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 215;
    }
 L1457: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 216;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1466: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1467;
    }
  goto L263;

 L1467: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 218;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L1481: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L1482;
    }
  goto L263;

 L1482: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 221;
    }
 L1487: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 222;
    }
  x1 = XEXP (x0, 1);
  goto L263;

 L264: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 42;
    }
 L268: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 43;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L2939: ATTRIBUTE_UNUSED_LABEL
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  goto L15;

 L2940: ATTRIBUTE_UNUSED_LABEL
  tem = recog_3 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  goto L15;

 L2942: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L302;
    }
 L2953: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L1573;
    }
  goto L15;

 L302: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode)
    goto L3062;
 L219: ATTRIBUTE_UNUSED_LABEL
  if (general_src_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L220;
    }
 L223: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L224;
    }
 L1610: ATTRIBUTE_UNUSED_LABEL
  if (GET_MODE (x1) == HImode
      && GET_CODE (x1) == SUBREG
      && XINT (x1, 1) == 6)
    goto L1611;
  x1 = XEXP (x0, 0);
  goto L2953;

 L3062: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case TRUNCATE:
      goto L303;
    case ZERO_EXTEND:
      goto L324;
    case SIGN_EXTEND:
      goto L356;
    case FIX:
      goto L458;
    case PLUS:
      goto L625;
    case MINUS:
      goto L782;
    case MULT:
      goto L874;
    case AND:
      goto L1229;
    case IOR:
      goto L1292;
    case XOR:
      goto L1363;
    case NEG:
      goto L1421;
    case NOT:
      goto L1506;
    default:
     break;
   }
  goto L219;

 L303: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_src_operand (x2, SImode))
    {
      operands[1] = x2;
      return 52;
    }
  goto L219;

 L324: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L325;
    }
  goto L219;

 L325: ATTRIBUTE_UNUSED_LABEL
  if ((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) != MEM))
    {
      return 57;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L356: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, QImode))
    {
      operands[1] = x2;
      return 64;
    }
  goto L219;

 L458: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == FIX)
    goto L459;
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L497;
    }
 L511: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L512;
    }
  goto L219;

 L459: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L460;
    }
  goto L219;

 L460: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 2;
      return 80;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L497: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 85;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L511;

 L512: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 88;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L625: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L626;
    }
  goto L219;

 L626: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L627;
    }
  goto L219;

 L627: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 101;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L782: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L783;
    }
  goto L219;

 L783: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L784;
    }
  goto L219;

 L784: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 122;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L874: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L875;
    }
  goto L219;

 L875: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[2] = x2;
      return 136;
    }
  goto L219;

 L1229: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1230;
    }
  goto L219;

 L1230: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1231;
    }
  goto L219;

 L1231: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 178;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L1292: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1293;
    }
  goto L219;

 L1293: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1294;
    }
  goto L219;

 L1294: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 188;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L1363: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1364;
    }
  goto L219;

 L1364: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1365;
    }
  goto L219;

 L1365: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 199;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L1421: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1422;
    }
  goto L219;

 L1422: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 209;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L1506: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1507;
    }
  goto L219;

 L1507: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 226;
    }
  x1 = XEXP (x0, 1);
  goto L219;

 L220: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 32;
    }
  x1 = XEXP (x0, 1);
  goto L223;

 L224: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 33;
    }
  x1 = XEXP (x0, 1);
  goto L1610;

 L1611: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode
      && GET_CODE (x2) == ASHIFTRT)
    goto L1612;
  x1 = XEXP (x0, 0);
  goto L2953;

 L1612: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L1613;
    }
  x1 = XEXP (x0, 0);
  goto L2953;

 L1613: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    {
      return 243;
    }
  x1 = XEXP (x0, 0);
  goto L2953;

 L1573: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode)
    goto L3074;
  x1 = XEXP (x0, 0);
  goto L15;

 L3074: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      goto L1574;
    case ASHIFTRT:
      goto L1657;
    case LSHIFTRT:
      goto L1721;
    case ROTATE:
      goto L1753;
    case ROTATERT:
      goto L1785;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L15;

 L1574: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1575;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1575: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1576;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1576: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 237;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1657: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1658;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1658: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1659;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1659: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 250;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1721: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1722;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1722: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1723;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1723: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 261;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1753: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1754;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1754: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1755;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1755: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 266;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1785: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L1786;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1786: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      operands[2] = x2;
      goto L1787;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L1787: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 271;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L2943: ATTRIBUTE_UNUSED_LABEL
  tem = recog_4 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  goto L15;

 L2944: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L374;
    }
  goto L15;

 L374: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SFmode)
    goto L3120;
 L255: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, SFmode))
    {
      operands[1] = x1;
      goto L256;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L3120: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case FLOAT_TRUNCATE:
      goto L375;
    case FLOAT:
      goto L390;
    case FIX:
      goto L486;
    case PLUS:
      goto L702;
    case MINUS:
      goto L841;
    case MULT:
      goto L1074;
    case DIV:
      goto L1134;
    case NEG:
      goto L1441;
    case SQRT:
      goto L1461;
    case ABS:
      goto L1471;
    default:
     break;
   }
  goto L255;

 L375: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L376;
    }
  goto L255;

 L376: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 68;
    }
 L381: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68040_ONLY))
    {
      return 69;
    }
 L386: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 70;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L390: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L391;
    }
 L410: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L411;
    }
 L420: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L421;
    }
  goto L255;

 L391: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 71;
    }
 L396: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 72;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L410;

 L411: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 75;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L420;

 L421: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 77;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L486: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L487;
    }
  goto L255;

 L487: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && !TARGET_68040))
    {
      return 83;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L702: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == FLOAT)
    goto L703;
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L697;
    }
  goto L255;

 L703: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L704;
    }
 L710: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L711;
    }
 L717: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L718;
    }
  goto L255;

 L704: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L705;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L710;

 L705: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 113;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L710;

 L711: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L712;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L717;

 L712: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 114;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L717;

 L718: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L719;
    }
  goto L255;

 L719: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 115;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L697: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[2] = x2;
      goto L698;
    }
  goto L255;

 L698: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 112;
    }
 L725: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 116;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L841: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L848;
    }
  goto L255;

 L848: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == FLOAT)
    goto L849;
  if (general_operand (x2, SFmode))
    {
      operands[2] = x2;
      goto L843;
    }
  goto L255;

 L849: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L850;
    }
 L856: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L857;
    }
 L863: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L864;
    }
  goto L255;

 L850: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 132;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L856;

 L857: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 133;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L863;

 L864: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 134;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L843: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 131;
    }
 L870: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 135;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1074: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == FLOAT)
    goto L1075;
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1069;
    }
  goto L255;

 L1075: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1076;
    }
 L1082: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1083;
    }
 L1089: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L1090;
    }
  goto L255;

 L1076: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1077;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1082;

 L1077: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 157;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1082;

 L1083: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1084;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1089;

 L1084: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 158;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1089;

 L1090: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1091;
    }
  goto L255;

 L1091: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 159;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1069: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[2] = x2;
      goto L1070;
    }
  goto L255;

 L1070: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 156;
    }
 L1097: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 160;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1134: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1141;
    }
  goto L255;

 L1141: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == FLOAT)
    goto L1142;
  if (general_operand (x2, SFmode))
    {
      operands[2] = x2;
      goto L1136;
    }
  goto L255;

 L1142: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1143;
    }
 L1149: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1150;
    }
 L1156: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L1157;
    }
  goto L255;

 L1143: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 167;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1149;

 L1150: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 168;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1156;

 L1157: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 169;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1136: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 166;
    }
 L1163: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 170;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1441: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1442;
    }
  goto L255;

 L1442: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 213;
    }
 L1447: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 214;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1461: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1462;
    }
  goto L255;

 L1462: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 217;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L1471: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L1472;
    }
  goto L255;

 L1472: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 219;
    }
 L1477: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 220;
    }
  x1 = XEXP (x0, 1);
  goto L255;

 L256: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 40;
    }
 L260: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 41;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L2946: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, XFmode))
    {
      operands[0] = x1;
      goto L271;
    }
  goto L15;

 L271: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (nonimmediate_operand (x1, XFmode))
    {
      operands[1] = x1;
      goto L272;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L272: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 44;
    }
 L276: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_68881 && ! TARGET_5200))
    {
      return 45;
    }
 L280: ATTRIBUTE_UNUSED_LABEL
  if ((! TARGET_68881 && TARGET_5200))
    {
      return 46;
    }
  x1 = XEXP (x0, 0);
  goto L15;

 L16: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case DImode:
      goto L3130;
    case SImode:
      goto L3131;
    case HImode:
      goto L3132;
    case QImode:
      goto L3133;
    default:
      break;
    }
 L67: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case COMPARE:
      goto L68;
    case ZERO_EXTRACT:
      goto L134;
    default:
     break;
   }
 L1964: ATTRIBUTE_UNUSED_LABEL
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == ZERO_EXTRACT)
    goto L1965;
  if (general_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L37;
    }
 L51: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L52;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3130: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L17;
    }
  goto L67;

 L17: ATTRIBUTE_UNUSED_LABEL
  if (pnum_clobbers != NULL)
    {
      *pnum_clobbers = 2;
      return 2;
    }
  x1 = XEXP (x0, 1);
  goto L67;

 L3131: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      return 3;
    }
  goto L67;

 L3132: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, HImode))
    {
      operands[0] = x1;
      return 4;
    }
  goto L67;

 L3133: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, QImode))
    {
      operands[0] = x1;
      return 5;
    }
  goto L67;

 L68: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      goto L3134;
    case HImode:
      goto L3135;
    case QImode:
      goto L3136;
    default:
      break;
    }
  if (general_operand (x2, DFmode))
    {
      operands[0] = x2;
      goto L102;
    }
 L122: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SFmode))
    {
      operands[0] = x2;
      goto L123;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3134: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L69;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L69: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L70;
    }
 L75: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L76;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L70: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 11;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  goto L75;

 L76: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 12;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3135: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_src_operand (x2, HImode))
    {
      operands[0] = x2;
      goto L81;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L81: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L82;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L82: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 13;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3136: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_src_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L87;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L87: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_src_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L88;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L88: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 14;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L102: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L103;
    }
  x2 = XEXP (x1, 0);
  goto L122;

 L103: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 15;
    }
 L109: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 16;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L122;

 L123: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L124;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L124: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 17;
    }
 L130: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 18;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L134: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L3137;
    case SImode:
      goto L3139;
    default:
      break;
    }
  goto L1964;

 L3137: ATTRIBUTE_UNUSED_LABEL
  if (memory_src_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L135;
    }
 L3138: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L144;
    }
  goto L1964;

 L135: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 1)
    goto L136;
  x2 = XEXP (x1, 0);
  goto L3138;

 L136: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == MINUS)
    goto L137;
  x2 = XEXP (x1, 0);
  goto L3138;

 L137: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 7)
    goto L138;
  x2 = XEXP (x1, 0);
  goto L3138;

 L138: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L139;
    }
  x2 = XEXP (x1, 0);
  goto L3138;

 L139: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 19;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L3138;

 L144: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 1)
    goto L145;
  goto L1964;

 L145: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == MINUS)
    goto L146;
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L183;
    }
  goto L1964;

 L146: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 7)
    goto L164;
  goto L1964;

 L164: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == AND)
    goto L165;
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L148;
    }
  goto L1964;

 L165: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      operands[1] = x4;
      goto L166;
    }
  goto L1964;

 L166: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 7)
    {
      return 22;
    }
  goto L1964;

 L148: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 20;
    }
  x1 = XEXP (x0, 1);
  goto L1964;

 L183: ATTRIBUTE_UNUSED_LABEL
  if (((unsigned) INTVAL (operands[1]) < 8 && !TARGET_5200))
    {
      return 24;
    }
  x1 = XEXP (x0, 1);
  goto L1964;

 L3139: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L153;
    }
  goto L1964;

 L153: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 1)
    goto L154;
  goto L1964;

 L154: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == MINUS)
    goto L155;
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L190;
    }
  goto L1964;

 L155: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 31)
    goto L174;
  goto L1964;

 L174: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == AND)
    goto L175;
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      return 21;
    }
  goto L1964;

 L175: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      operands[1] = x4;
      goto L176;
    }
  goto L1964;

 L176: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 31)
    {
      return 23;
    }
  goto L1964;

 L190: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 25;
    }
 L197: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_5200))
    {
      return 26;
    }
  x1 = XEXP (x0, 1);
  goto L1964;

 L1965: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      goto L3140;
    case SImode:
      goto L3141;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3140: ATTRIBUTE_UNUSED_LABEL
  if (memory_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L1966;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1966: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1967;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1967: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1968;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1968: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 296;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L3141: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L1973;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1973: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (const_int_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1974;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1974: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L1975;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L1975: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && TARGET_BITFIELD))
    {
      return 297;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L37: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 6;
    }
 L41: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 7;
    }
  x1 = XEXP (x0, 1);
  goto L51;

 L52: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA)
      && pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 8;
    }
 L56: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 9;
    }
  x1 = XEXP (x0, 0);
  goto L2588;

 L227: ATTRIBUTE_UNUSED_LABEL
  tem = recog_5 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  goto L2588;

 L2126: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L2127;
    case LABEL_REF:
      goto L2497;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2588;

 L2127: ATTRIBUTE_UNUSED_LABEL
  tem = recog_6 (x0, insn, pnum_clobbers);
  if (tem >= 0)
    return tem;
  x1 = XEXP (x0, 0);
  goto L2588;

 L2497: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  return 363;

 L2589: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL)
    goto L2590;
  x1 = XEXP (x0, 0);
  goto L2608;

 L2590: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (memory_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L2591;
    }
  x1 = XEXP (x0, 0);
  goto L2608;

 L2591: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L2592;
    }
  x1 = XEXP (x0, 0);
  goto L2608;

 L2592: ATTRIBUTE_UNUSED_LABEL
  if ((! flag_pic))
    {
      return 372;
    }
 L2598: ATTRIBUTE_UNUSED_LABEL
  if ((flag_pic))
    {
      return 373;
    }
  x1 = XEXP (x0, 0);
  goto L2608;

 L2958: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L2768;
    }
  goto L2605;

 L2768: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == FIX)
    goto L2769;
  if (address_operand (x1, QImode))
    {
      operands[1] = x1;
      return 379;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2769: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2770;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2770: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 404;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2959: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L2612;
    }
 L2962: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L2728;
    }
  goto L2605;

 L2612: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DFmode)
    goto L3170;
  x1 = XEXP (x0, 0);
  goto L2962;

 L3170: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L2613;
    case MINUS:
      goto L2645;
    case MULT:
      goto L2661;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2613: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == MULT)
    goto L2614;
  x1 = XEXP (x0, 0);
  goto L2962;

 L2614: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L2615;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2615: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2616;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2616: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[3] = x2;
      goto L2617;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2617: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 380;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2645: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == MULT)
    goto L2646;
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L2630;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2646: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L2647;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2647: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2648;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2648: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[3] = x2;
      goto L2649;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2649: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 384;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2630: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == MULT)
    goto L2631;
  x1 = XEXP (x0, 0);
  goto L2962;

 L2631: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2632;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2632: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[3] = x3;
      goto L2633;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2633: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 382;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2661: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DFmode)
    goto L3173;
 L2685: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L2686;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L3173: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case PLUS:
      goto L2662;
    case MINUS:
      goto L2678;
    default:
     break;
   }
  goto L2685;

 L2662: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L2663;
    }
  goto L2685;

 L2663: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2664;
    }
  goto L2685;

 L2664: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[3] = x2;
      goto L2665;
    }
  x2 = XEXP (x1, 0);
  goto L2685;

 L2665: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 386;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2685;

 L2678: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L2679;
    }
  goto L2685;

 L2679: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2680;
    }
  goto L2685;

 L2680: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, DFmode))
    {
      operands[3] = x2;
      goto L2681;
    }
  x2 = XEXP (x1, 0);
  goto L2685;

 L2681: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 388;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2685;

 L2686: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode
      && GET_CODE (x2) == MINUS)
    goto L2687;
  x1 = XEXP (x0, 0);
  goto L2962;

 L2687: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DFmode))
    {
      operands[2] = x3;
      goto L2688;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2688: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[3] = x3;
      goto L2689;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2689: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 389;
    }
  x1 = XEXP (x0, 0);
  goto L2962;

 L2728: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DFmode)
    goto L3175;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3175: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case FLOAT_TRUNCATE:
      goto L2729;
    case UNSPEC:
      goto L3178;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2729: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2730;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2730: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 396;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L3178: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x1, 0) == 1)
    goto L3180;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3180: ATTRIBUTE_UNUSED_LABEL
  switch (XINT (x1, 1))
    {
    case 1:
      goto L2902;
    case 2:
      goto L2917;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2902: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L2903;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2903: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 425;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2917: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L2918;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2918: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 428;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2960: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L2620;
    }
 L2963: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L2733;
    }
  goto L2605;

 L2620: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SFmode)
    goto L3182;
  x1 = XEXP (x0, 0);
  goto L2963;

 L3182: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L2621;
    case MINUS:
      goto L2653;
    case MULT:
      goto L2669;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2621: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == MULT)
    goto L2622;
  x1 = XEXP (x0, 0);
  goto L2963;

 L2622: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L2623;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2623: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2624;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2624: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[3] = x2;
      goto L2625;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2625: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 381;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2653: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == MULT)
    goto L2654;
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L2638;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2654: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L2655;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2655: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2656;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2656: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[3] = x2;
      goto L2657;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2657: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 385;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2638: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == MULT)
    goto L2639;
  x1 = XEXP (x0, 0);
  goto L2963;

 L2639: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2640;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2640: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[3] = x3;
      goto L2641;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2641: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 383;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2669: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SFmode)
    goto L3185;
 L2701: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L2702;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L3185: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case PLUS:
      goto L2670;
    case MINUS:
      goto L2694;
    default:
     break;
   }
  goto L2701;

 L2670: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L2671;
    }
  goto L2701;

 L2671: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2672;
    }
  goto L2701;

 L2672: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[3] = x2;
      goto L2673;
    }
  x2 = XEXP (x1, 0);
  goto L2701;

 L2673: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 387;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2701;

 L2694: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L2695;
    }
  goto L2701;

 L2695: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2696;
    }
  goto L2701;

 L2696: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SFmode))
    {
      operands[3] = x2;
      goto L2697;
    }
  x2 = XEXP (x1, 0);
  goto L2701;

 L2697: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 390;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2701;

 L2702: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SFmode
      && GET_CODE (x2) == MINUS)
    goto L2703;
  x1 = XEXP (x0, 0);
  goto L2963;

 L2703: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SFmode))
    {
      operands[2] = x3;
      goto L2704;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2704: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[3] = x3;
      goto L2705;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2705: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 391;
    }
  x1 = XEXP (x0, 0);
  goto L2963;

 L2733: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SFmode)
    goto L3187;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3187: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case FLOAT_TRUNCATE:
      goto L2734;
    case UNSPEC:
      goto L3190;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2734: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2735;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2735: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 397;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L3190: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x1, 0) == 1)
    goto L3192;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3192: ATTRIBUTE_UNUSED_LABEL
  switch (XINT (x1, 1))
    {
    case 1:
      goto L2897;
    case 2:
      goto L2912;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2897: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L2898;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2898: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 424;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2912: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L2913;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2913: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 427;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2961: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, XFmode))
    {
      operands[0] = x1;
      goto L2718;
    }
  goto L2605;

 L2718: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == XFmode)
    goto L3194;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3194: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case FLOAT_EXTEND:
      goto L2719;
    case FLOAT:
      goto L2739;
    case FIX:
      goto L2754;
    case PLUS:
      goto L2774;
    case MINUS:
      goto L2801;
    case MULT:
      goto L2828;
    case DIV:
      goto L2855;
    case NEG:
      goto L2882;
    case ABS:
      goto L2887;
    case SQRT:
      goto L2892;
    case UNSPEC:
      goto L3206;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2719: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SFmode))
    {
      operands[1] = x2;
      goto L2720;
    }
 L2724: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[1] = x2;
      goto L2725;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2720: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 394;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2724;

 L2725: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 395;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2739: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L2740;
    }
 L2744: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, HImode))
    {
      operands[1] = x2;
      goto L2745;
    }
 L2749: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, QImode))
    {
      operands[1] = x2;
      goto L2750;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2740: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 398;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2744;

 L2745: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 399;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  goto L2749;

 L2750: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 400;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2754: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2755;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2755: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 401;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2774: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == XFmode)
    goto L3208;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3208: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FLOAT)
    goto L2775;
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2796;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2775: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L2776;
    }
 L2782: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L2783;
    }
 L2789: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L2790;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2776: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2777;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2782;

 L2777: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 405;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2782;

 L2783: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2784;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2789;

 L2784: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 406;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2789;

 L2790: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2791;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2791: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 407;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2796: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[2] = x2;
      goto L2797;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2797: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 408;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2801: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2802;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2802: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == XFmode)
    goto L3210;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3210: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FLOAT)
    goto L2803;
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[2] = x2;
      goto L2824;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2803: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L2804;
    }
 L2810: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L2811;
    }
 L2817: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L2818;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2804: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 409;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L2810;

 L2811: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 410;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L2817;

 L2818: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 411;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2824: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 412;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2828: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == XFmode)
    goto L3212;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3212: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FLOAT)
    goto L2829;
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2850;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2829: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L2830;
    }
 L2836: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L2837;
    }
 L2843: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L2844;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2830: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2831;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2836;

 L2831: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 413;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2836;

 L2837: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2838;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2843;

 L2838: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 414;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L2843;

 L2844: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2845;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2845: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 415;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2850: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[2] = x2;
      goto L2851;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2851: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 416;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2855: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2856;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2856: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == XFmode)
    goto L3214;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3214: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == FLOAT)
    goto L2857;
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[2] = x2;
      goto L2878;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2857: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L2858;
    }
 L2864: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L2865;
    }
 L2871: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, QImode))
    {
      operands[2] = x3;
      goto L2872;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2858: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 417;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L2864;

 L2865: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 418;
    }
  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L2871;

 L2872: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 419;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2878: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 420;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2882: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2883;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2883: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 421;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2887: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2888;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2888: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 422;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2892: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2893;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2893: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 423;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L3206: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x1, 0) == 1)
    goto L3216;
  x1 = XEXP (x0, 0);
  goto L2605;

 L3216: ATTRIBUTE_UNUSED_LABEL
  switch (XINT (x1, 1))
    {
    case 1:
      goto L2907;
    case 2:
      goto L2922;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2907: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2908;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2908: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 426;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2922: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2923;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2923: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && flag_unsafe_math_optimizations))
    {
      return 429;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2964: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L2758;
    }
  goto L2605;

 L2758: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode
      && GET_CODE (x1) == FIX)
    goto L2759;
  x1 = XEXP (x0, 0);
  goto L2605;

 L2759: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2760;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2760: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 402;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2965: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L2763;
    }
  goto L2605;

 L2763: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode
      && GET_CODE (x1) == FIX)
    goto L2764;
  x1 = XEXP (x0, 0);
  goto L2605;

 L2764: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (general_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2765;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2765: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 403;
    }
  x1 = XEXP (x0, 0);
  goto L2605;

 L2606: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (address_operand (x1, SImode))
    {
      operands[0] = x1;
      return 378;
    }
  goto ret0;

 L2708: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (nonimmediate_operand (x1, XFmode))
    {
      operands[0] = x1;
      goto L2709;
    }
  if (GET_CODE (x1) == COMPARE)
    goto L2713;
  goto ret0;

 L2709: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 392;
    }
  goto ret0;

 L2713: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[0] = x2;
      goto L2714;
    }
  goto ret0;

 L2714: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, XFmode))
    {
      operands[1] = x2;
      goto L2715;
    }
  goto ret0;

 L2715: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881))
    {
      return 393;
    }
  goto ret0;
 ret0:
  return -1;
}

static int recog_8 PARAMS ((rtx, rtx, int *));
static int
recog_8 (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DImode:
      goto L3221;
    case SImode:
      goto L3222;
    case HImode:
      goto L3224;
    default:
      break;
    }
 L29: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case CC0:
      goto L60;
    case PC:
      goto L2501;
    default:
     break;
   }
  goto ret0;

 L3221: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, DImode))
    {
      operands[0] = x2;
      goto L533;
    }
  goto L29;

 L533: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode)
    goto L3225;
  x2 = XEXP (x1, 0);
  goto L29;

 L3225: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case PLUS:
      goto L534;
    case MINUS:
      goto L730;
    case ASHIFT:
      goto L1533;
    case ASHIFTRT:
      goto L1629;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L29;

 L534: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode)
    goto L3229;
 L586: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L587;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L3229: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      goto L535;
    case ASHIFT:
      goto L552;
    default:
     break;
   }
  goto L586;

 L535: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, DImode))
    {
      operands[1] = x4;
      goto L536;
    }
  goto L586;

 L536: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 63)
    goto L537;
  goto L586;

 L537: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[1]))
    goto L538;
  x3 = XEXP (x2, 0);
  goto L586;

 L538: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L539;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L586;

 L539: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      return 92;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L586;

 L552: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode
      && GET_CODE (x4) == SIGN_EXTEND)
    goto L553;
  goto L586;

 L553: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (general_operand (x5, HImode))
    {
      operands[1] = x5;
      goto L554;
    }
  goto L586;

 L554: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L555;
  goto L586;

 L555: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DImode))
    {
      operands[2] = x3;
      goto L556;
    }
  x3 = XEXP (x2, 0);
  goto L586;

 L556: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L557;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L586;

 L557: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L558;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L586;

 L558: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 93;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L586;

 L587: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DImode))
    {
      operands[2] = x3;
      goto L588;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L588: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L589;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L589: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      return 96;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L730: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L731;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L731: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == ASHIFT)
    goto L732;
  if (general_operand (x3, DImode))
    {
      operands[2] = x3;
      goto L759;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L732: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode
      && GET_CODE (x4) == SIGN_EXTEND)
    goto L733;
  x2 = XEXP (x1, 0);
  goto L29;

 L733: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (general_operand (x5, HImode))
    {
      operands[2] = x5;
      goto L734;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L734: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L735;
  x2 = XEXP (x1, 0);
  goto L29;

 L735: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L736;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L736: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L737;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L737: ATTRIBUTE_UNUSED_LABEL
  if ((!TARGET_5200))
    {
      return 117;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L759: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L760;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L760: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      return 119;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1533: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == SIGN_EXTEND)
    goto L1534;
  x2 = XEXP (x1, 0);
  goto L29;

 L1534: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, HImode))
    {
      operands[1] = x4;
      goto L1535;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1535: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    goto L1536;
  x2 = XEXP (x1, 0);
  goto L29;

 L1536: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L1537;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1537: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      return 231;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1629: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L1630;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1630: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == 32)
    goto L1631;
  x2 = XEXP (x1, 0);
  goto L29;

 L1631: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L1632;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1632: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      return 246;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L3222: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L919;
    }
 L3223: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L1167;
    }
  goto L29;

 L919: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode)
    goto L3231;
  x2 = XEXP (x1, 0);
  goto L3223;

 L3231: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case MULT:
      goto L920;
    case TRUNCATE:
      goto L982;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L3223;

 L920: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L921;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L921: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (nonimmediate_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L922;
    }
  if (const_int_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L938;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L922: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L923;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L923: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L924;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L924: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == TRUNCATE)
    goto L925;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L925: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == LSHIFTRT)
    goto L926;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L926: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode
      && GET_CODE (x4) == MULT)
    goto L927;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L927: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) == DImode)
    goto L3233;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L3233: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      goto L928;
    case SIGN_EXTEND:
      goto L959;
    default:
     break;
   }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L928: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    goto L929;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L929: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) == DImode
      && GET_CODE (x5) == ZERO_EXTEND)
    goto L930;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L930: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[2]))
    goto L931;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L931: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32
      && (TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 143;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L959: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    goto L960;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L960: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) == DImode
      && GET_CODE (x5) == SIGN_EXTEND)
    goto L961;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L961: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[2]))
    goto L962;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L962: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32
      && (TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 145;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L938: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L939;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L939: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L940;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L940: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == TRUNCATE)
    goto L941;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L941: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == LSHIFTRT)
    goto L942;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L942: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode
      && GET_CODE (x4) == MULT)
    goto L943;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L943: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) == DImode)
    goto L3235;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L3235: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      goto L944;
    case SIGN_EXTEND:
      goto L975;
    default:
     break;
   }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L944: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    goto L945;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L945: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (rtx_equal_p (x5, operands[2]))
    goto L946;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L946: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32
      && (TARGET_68020 && !TARGET_68060 && !TARGET_5200
   && (unsigned) INTVAL (operands[2]) <= 0x7fffffff))
    {
      return 144;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L975: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    goto L976;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L976: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (rtx_equal_p (x5, operands[2]))
    goto L977;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L977: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32
      && (TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 146;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L982: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode
      && GET_CODE (x3) == LSHIFTRT)
    goto L983;
  x2 = XEXP (x1, 0);
  goto L3223;

 L983: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode
      && GET_CODE (x4) == MULT)
    goto L984;
  x2 = XEXP (x1, 0);
  goto L3223;

 L984: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) == DImode)
    goto L3237;
  x2 = XEXP (x1, 0);
  goto L3223;

 L3237: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      goto L985;
    case SIGN_EXTEND:
      goto L1012;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L3223;

 L985: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (register_operand (x6, SImode))
    {
      operands[2] = x6;
      goto L986;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L986: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) == DImode
      && GET_CODE (x5) == ZERO_EXTEND)
    goto L987;
  if (const_uint32_operand (x5, DImode))
    {
      operands[3] = x5;
      goto L1001;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L987: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (nonimmediate_operand (x6, SImode))
    {
      operands[3] = x6;
      goto L988;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L988: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L989;
  x2 = XEXP (x1, 0);
  goto L3223;

 L989: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L990;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L990: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L991;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L991: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 147;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1001: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L1002;
  x2 = XEXP (x1, 0);
  goto L3223;

 L1002: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L1003;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1003: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1004;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1004: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 148;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1012: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (register_operand (x6, SImode))
    {
      operands[2] = x6;
      goto L1013;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L1013: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) == DImode
      && GET_CODE (x5) == SIGN_EXTEND)
    goto L1014;
  if (const_sint32_operand (x5, DImode))
    {
      operands[3] = x5;
      goto L1028;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L1014: ATTRIBUTE_UNUSED_LABEL
  x6 = XEXP (x5, 0);
  if (nonimmediate_operand (x6, SImode))
    {
      operands[3] = x6;
      goto L1015;
    }
  x2 = XEXP (x1, 0);
  goto L3223;

 L1015: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L1016;
  x2 = XEXP (x1, 0);
  goto L3223;

 L1016: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L1017;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1017: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1018;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1018: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 149;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1028: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 32)
    goto L1029;
  x2 = XEXP (x1, 0);
  goto L3223;

 L1029: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L1030;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1030: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L1031;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1031: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && !TARGET_68060 && !TARGET_5200))
    {
      return 150;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L3223;

 L1167: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode)
    goto L3239;
  x2 = XEXP (x1, 0);
  goto L29;

 L3239: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case DIV:
      goto L1168;
    case UDIV:
      goto L1179;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L29;

 L1168: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L1169;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1169: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_src_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1170;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1170: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L1171;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1171: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1172;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1172: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == MOD)
    goto L1173;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1173: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[1]))
    goto L1174;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1174: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[2])
      && (TARGET_68020 && !TARGET_5200))
    {
      return 171;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1179: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L1180;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1180: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_src_operand (x3, SImode))
    {
      operands[2] = x3;
      goto L1181;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1181: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L1182;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1182: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L1183;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1183: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == UMOD)
    goto L1184;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1184: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[1]))
    goto L1185;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1185: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[2])
      && (TARGET_68020 && !TARGET_5200))
    {
      return 172;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L3224: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[0] = x2;
      goto L1189;
    }
  goto L29;

 L1189: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode)
    goto L3241;
  x2 = XEXP (x1, 0);
  goto L29;

 L3241: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case DIV:
      goto L1190;
    case UDIV:
      goto L1201;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L29;

 L1190: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L1191;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1191: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_src_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1192;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1192: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L1193;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1193: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, HImode))
    {
      operands[3] = x2;
      goto L1194;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1194: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode
      && GET_CODE (x2) == MOD)
    goto L1195;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1195: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[1]))
    goto L1196;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1196: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[2])
      && (!TARGET_5200))
    {
      return 173;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1201: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L1202;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1202: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_src_operand (x3, HImode))
    {
      operands[2] = x3;
      goto L1203;
    }
  x2 = XEXP (x1, 0);
  goto L29;

 L1203: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L1204;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1204: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, HImode))
    {
      operands[3] = x2;
      goto L1205;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1205: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode
      && GET_CODE (x2) == UMOD)
    goto L1206;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1206: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[1]))
    goto L1207;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L1207: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, operands[2])
      && (!TARGET_5200))
    {
      return 174;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L29;

 L60: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == COMPARE)
    goto L61;
  if (general_operand (x2, SFmode))
    {
      operands[0] = x2;
      goto L31;
    }
 L45: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x2, DFmode))
    {
      operands[0] = x2;
      goto L46;
    }
  goto ret0;

 L61: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (nonimmediate_operand (x3, DImode))
    {
      operands[1] = x3;
      goto L62;
    }
  if (general_operand (x3, DFmode))
    {
      operands[0] = x3;
      goto L94;
    }
 L114: ATTRIBUTE_UNUSED_LABEL
  if (general_operand (x3, SFmode))
    {
      operands[0] = x3;
      goto L115;
    }
  goto ret0;

 L62: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DImode))
    {
      operands[2] = x3;
      goto L63;
    }
  goto ret0;

 L63: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L64;
  goto ret0;

 L64: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      operands[0] = x2;
      return 10;
    }
  goto ret0;

 L94: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, DFmode))
    {
      operands[1] = x3;
      goto L95;
    }
  x3 = XEXP (x2, 0);
  goto L114;

 L95: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L96;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L114;

 L96: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L97;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L114;

 L97: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 15;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L114;

 L115: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (general_operand (x3, SFmode))
    {
      operands[1] = x3;
      goto L116;
    }
  goto ret0;

 L116: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L117;
  goto ret0;

 L117: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L118;
    }
  goto ret0;

 L118: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 17;
    }
  goto ret0;

 L31: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L32;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L45;

 L32: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L33;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L45;

 L33: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 6;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L45;

 L46: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L47;
  goto ret0;

 L47: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L48;
    }
  goto ret0;

 L48: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_FPA))
    {
      return 8;
    }
  goto ret0;

 L2501: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode)
    goto L3244;
 L2115: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == IF_THEN_ELSE)
    goto L2116;
  goto ret0;

 L3244: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == PLUS)
    goto L2509;
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L2502;
    }
  goto L2115;

 L2509: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == PC)
    goto L2510;
  goto L2115;

 L2510: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == SIGN_EXTEND)
    goto L2511;
  goto L2115;

 L2511: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, HImode))
    {
      operands[0] = x4;
      goto L2512;
    }
  goto L2115;

 L2512: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE)
    goto L2513;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L2115;

 L2513: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2514;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L2115;

 L2514: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  return 365;

 L2502: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE)
    goto L2503;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L2115;

 L2503: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF)
    goto L2504;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L2115;

 L2504: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  return 364;

 L2116: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      goto L2117;
    case NE:
      goto L2520;
    case GE:
      goto L2550;
    default:
     break;
   }
  goto ret0;

 L2117: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (general_operand (x4, DImode))
    {
      operands[0] = x4;
      goto L2118;
    }
  goto ret0;

 L2118: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2119;
  goto ret0;

 L2119: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2120;
  goto ret0;

 L2120: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2121;

 L2121: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2122;
  goto ret0;

 L2122: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L2123;
  goto ret0;

 L2123: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      return 324;
    }
  goto ret0;

 L2520: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case HImode:
      goto L3245;
    case SImode:
      goto L3246;
    default:
      break;
    }
  if (general_operand (x4, DImode))
    {
      operands[0] = x4;
      goto L2139;
    }
  goto ret0;

 L3245: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x4, HImode))
    {
      operands[0] = x4;
      goto L2521;
    }
  goto ret0;

 L2521: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2522;
  goto ret0;

 L2522: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2523;
  goto ret0;

 L2523: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2524;

 L2524: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2525;
  goto ret0;

 L2525: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L2526;
  goto ret0;

 L2526: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L2527;
  goto ret0;

 L2527: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode
      && GET_CODE (x2) == PLUS)
    goto L2528;
  goto ret0;

 L2528: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[0]))
    goto L2529;
  goto ret0;

 L2529: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == -1
      && (!TARGET_5200))
    {
      return 366;
    }
  goto ret0;

 L3246: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x4, SImode))
    {
      operands[0] = x4;
      goto L2536;
    }
  goto ret0;

 L2536: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2537;
  goto ret0;

 L2537: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2538;
  goto ret0;

 L2538: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2539;

 L2539: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2540;
  goto ret0;

 L2540: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L2541;
  goto ret0;

 L2541: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L2542;
  goto ret0;

 L2542: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == PLUS)
    goto L2543;
  goto ret0;

 L2543: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[0]))
    goto L2544;
  goto ret0;

 L2544: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == -1
      && (!TARGET_5200))
    {
      return 367;
    }
  goto ret0;

 L2139: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2140;
  goto ret0;

 L2140: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2141;
  goto ret0;

 L2141: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2142;

 L2142: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2143;
  goto ret0;

 L2143: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L2144;
  goto ret0;

 L2144: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      return 325;
    }
  goto ret0;

 L2550: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case HImode:
      goto L3247;
    case SImode:
      goto L3248;
    default:
      break;
    }
  goto ret0;

 L3247: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x4) == PLUS)
    goto L2551;
  goto ret0;

 L2551: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (nonimmediate_operand (x5, HImode))
    {
      operands[0] = x5;
      goto L2552;
    }
  goto ret0;

 L2552: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT
      && XWINT (x5, 0) == -1)
    goto L2553;
  goto ret0;

 L2553: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2554;
  goto ret0;

 L2554: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2555;
  goto ret0;

 L2555: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2556;

 L2556: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2557;
  goto ret0;

 L2557: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L2558;
  goto ret0;

 L2558: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L2559;
  goto ret0;

 L2559: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode
      && GET_CODE (x2) == PLUS)
    goto L2560;
  goto ret0;

 L2560: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[0]))
    goto L2561;
  goto ret0;

 L2561: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == -1
      && (!TARGET_5200 && find_reg_note (insn, REG_NONNEG, 0)))
    {
      return 368;
    }
  goto ret0;

 L3248: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x4) == PLUS)
    goto L2568;
  goto ret0;

 L2568: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 0);
  if (nonimmediate_operand (x5, SImode))
    {
      operands[0] = x5;
      goto L2569;
    }
  goto ret0;

 L2569: ATTRIBUTE_UNUSED_LABEL
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT
      && XWINT (x5, 0) == -1)
    goto L2570;
  goto ret0;

 L2570: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT
      && XWINT (x4, 0) == 0)
    goto L2571;
  goto ret0;

 L2571: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF)
    goto L2572;
  goto ret0;

 L2572: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  goto L2573;

 L2573: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC)
    goto L2574;
  goto ret0;

 L2574: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET)
    goto L2575;
  goto ret0;

 L2575: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, operands[0]))
    goto L2576;
  goto ret0;

 L2576: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == PLUS)
    goto L2577;
  goto ret0;

 L2577: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, operands[0]))
    goto L2578;
  goto ret0;

 L2578: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT
      && XWINT (x3, 0) == -1
      && (!TARGET_5200 && find_reg_note (insn, REG_NONNEG, 0)))
    {
      return 369;
    }
  goto ret0;
 ret0:
  return -1;
}

int recog PARAMS ((rtx, rtx, int *));
int
recog (x0, insn, pnum_clobbers)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
     int *pnum_clobbers ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;

  if (GET_MODE (x0) == SImode
      && GET_CODE (x0) == REG
      && XINT (x0, 0) == 15
      && (NEED_PROBE))
    {
      return 376;
    }
  switch (GET_CODE (x0))
    {
    case SET:
      goto L1;
    case PARALLEL:
      goto L2933;
    case CALL:
      goto L2580;
    case UNSPEC_VOLATILE:
      goto L2935;
    case CONST_INT:
      goto L2936;
    case RETURN:
      goto L2937;
    case TRAP_IF:
      goto L2925;
    default:
     break;
   }
  goto ret0;

 L1: ATTRIBUTE_UNUSED_LABEL
  return recog_7 (x0, insn, pnum_clobbers);

 L2933: ATTRIBUTE_UNUSED_LABEL
  switch (XVECLEN (x0, 0))
    {
    case 3:
      goto L7;
    case 2:
      goto L28;
    default:
      break;
    }
  goto ret0;

 L7: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET)
    goto L429;
  goto ret0;

 L429: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      goto L3218;
    case HImode:
      goto L3219;
    case QImode:
      goto L3220;
    default:
      break;
    }
 L8: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == CC0)
    goto L9;
  goto ret0;

 L3218: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L430;
    }
  goto L8;

 L430: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == FIX)
    goto L431;
  x2 = XEXP (x1, 0);
  goto L8;

 L431: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DFmode
      && GET_CODE (x3) == FIX)
    goto L432;
  x2 = XEXP (x1, 0);
  goto L8;

 L432: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, DFmode))
    {
      operands[1] = x4;
      goto L433;
    }
  x2 = XEXP (x1, 0);
  goto L8;

 L433: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L434;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L434: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L435;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L435: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER)
    goto L436;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L436: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L437;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L437: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040))
    {
      return 79;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L3219: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, HImode))
    {
      operands[0] = x2;
      goto L447;
    }
  goto L8;

 L447: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode
      && GET_CODE (x2) == FIX)
    goto L448;
  x2 = XEXP (x1, 0);
  goto L8;

 L448: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DFmode
      && GET_CODE (x3) == FIX)
    goto L449;
  x2 = XEXP (x1, 0);
  goto L8;

 L449: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, DFmode))
    {
      operands[1] = x4;
      goto L450;
    }
  x2 = XEXP (x1, 0);
  goto L8;

 L450: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L451;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L451: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L452;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L452: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER)
    goto L453;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L453: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L454;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L454: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040))
    {
      return 80;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L3220: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x2, QImode))
    {
      operands[0] = x2;
      goto L464;
    }
  goto L8;

 L464: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == QImode
      && GET_CODE (x2) == FIX)
    goto L465;
  x2 = XEXP (x1, 0);
  goto L8;

 L465: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DFmode
      && GET_CODE (x3) == FIX)
    goto L466;
  x2 = XEXP (x1, 0);
  goto L8;

 L466: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, DFmode))
    {
      operands[1] = x4;
      goto L467;
    }
  x2 = XEXP (x1, 0);
  goto L8;

 L467: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L468;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L468: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L469;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L469: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER)
    goto L470;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L470: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[3] = x2;
      goto L471;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L471: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68881 && TARGET_68040))
    {
      return 81;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L8;

 L9: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (nonimmediate_operand (x2, DImode))
    {
      operands[0] = x2;
      goto L10;
    }
  goto ret0;

 L10: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L11;
  goto ret0;

 L11: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L12;
    }
  goto ret0;

 L12: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER)
    goto L13;
  goto ret0;

 L13: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DImode))
    {
      operands[2] = x2;
      return 2;
    }
  goto ret0;

 L28: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET)
    goto L532;
  goto ret0;

 L532: ATTRIBUTE_UNUSED_LABEL
  return recog_8 (x0, insn, pnum_clobbers);

 L2580: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (memory_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L2581;
    }
  goto ret0;

 L2581: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (general_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L2582;
    }
  goto ret0;

 L2582: ATTRIBUTE_UNUSED_LABEL
  if ((! flag_pic))
    {
      return 370;
    }
 L2586: ATTRIBUTE_UNUSED_LABEL
  if ((flag_pic))
    {
      return 371;
    }
  goto ret0;

 L2935: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x0, 0) == 1
      && XINT (x0, 1) == 0)
    goto L2600;
  goto ret0;

 L2600: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == 0)
    {
      return 374;
    }
  goto ret0;

 L2936: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x0, 0) == 0)
    {
      return 375;
    }
  goto ret0;

 L2937: ATTRIBUTE_UNUSED_LABEL
  if ((USE_RETURN_INSN))
    {
      return 377;
    }
  goto ret0;

 L2925: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == -1)
    goto L2926;
  if (valid_dbcc_comparison_p (x1, VOIDmode))
    {
      operands[0] = x1;
      goto L2929;
    }
  goto ret0;

 L2926: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CONST_INT
      && XWINT (x1, 0) == 7)
    {
      return 430;
    }
  goto ret0;

 L2929: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CC0)
    goto L2930;
  goto ret0;

 L2930: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT
      && XWINT (x2, 0) == 0)
    goto L2931;
  goto ret0;

 L2931: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (const_int_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L2932;
    }
  goto ret0;

 L2932: ATTRIBUTE_UNUSED_LABEL
  if ((TARGET_68020 && ! flags_in_68881 ()))
    {
      return 431;
    }
  goto ret0;
 ret0:
  return -1;
}

rtx split_insns PARAMS ((rtx, rtx));
rtx
split_insns (x0, insn)
     rtx x0 ATTRIBUTE_UNUSED;
     rtx insn ATTRIBUTE_UNUSED;
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx x5 ATTRIBUTE_UNUSED;
  rtx x6 ATTRIBUTE_UNUSED;
  rtx tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;
  goto ret0;
 ret0:
  return 0;
}

